/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _CHATSNDWIN_
#define _CHATSNDWIN_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qpushbt.h>
#include <qgrpbox.h>
#include <qdialog.h>
#include <qlined.h>
#include <qlabel.h>
#include <qmlined.h>

#include "icqwindow.h"

class ChatSndWindow : public IcqWindow {
  Q_OBJECT
public:
  ChatSndWindow(const char*, unsigned long, const char*);
  ~ChatSndWindow();
  void setUIN(unsigned long);
  void setName(const char*);
  void setEMail(const char*);
  void stopCommand();
  void saveHistory();
  void requestNotify(int type, int length, void *data);
public slots:
signals:
protected:
  unsigned long uin;
  QString message;
  QPushButton *sendbutton, *cancelbutton;
  QGroupBox *tobox;
  QLabel *uinlabel, *handlelabel, *emaillabel;
  QLineEdit *uinline, *handleline, *emailline;
  QPushButton *infobutton;
  QLabel *editlabel; /*, *urllabel; */
  QMultiLineEdit *editbox;
  /* QLineEdit *urlbox; */
  QLabel *updateanim;
  long sendSeq;
  void resizeEvent(QResizeEvent *);
protected slots:
  void sendChatReq();
  void cancelChatReq();
  void infoRequest();
private:
private slots:
};
#endif /* _CHATSNDWIN_ */
