/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _BLINKLISTBOX_H
#define _BLINKLISTBOX_H

#include <qpixmap.h>
#include <qfont.h>
#include <qpainter.h>
#include <qlistbox.h>
#include <qpixmap.h>
#include <kapp.h>

#include "virtuseritem.h"

enum blPaintMode {FREEZE, VANISH};

class WBlinkListBoxItem : public VirtUserItem
{
public:
  WBlinkListBoxItem(const char*);
  WBlinkListBoxItem();
  void setPixmap(int, const QPixmap&);
  void setPixmapXY(int,int);
  void setPaintMode(blPaintMode);
  int togglePixmap();
  void resetPixmap();
  void setBlinking(int);
  int isBlinking();
  int pixmapMaxWidth() const;
  int pixmapMaxHeight() const;
  int pixmapX() const { return pmapX; }
  int pixmapY() const { return pmapY; }
protected:
  virtual void paint(QPainter*);
  virtual const QPixmap *pixmap();
  const QPixmap *activePixmap() const;
  virtual int height(const QListBox*) const;
  virtual int width(const QListBox*) const;
  int isBlinkingFlag;
  QPixmap pmap1, pmap2;
  int activePixmapNo;
  int pmapX,pmapY;
  blPaintMode paintMode;
};
#endif /* _BLINKLISTBOX_H */
