/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: systemitem.cpp,v 1.1 2000/06/17 17:38:03 denis Exp $
// $Log: systemitem.cpp,v $
// Revision 1.1  2000/06/17 17:38:03  denis
// Contact List code was rewritten from scratch! Although we are trying
// to not add new features in anticipation of the next stable release,
// but this rewrite solves many things, removes many hacks and stabilizes
// whole program.
// One of bug, needs to mention, is an absence of IP address in Info
// window. The root of problem was in Contact List, because in any time
// there were several ContactItems in memory for single user - they were
// "smeared" on the whole code. Now it's clean and strict - all Contact
// List operations can be done only by ContactList class.
//

#include <kapp.h>
#include <kiconloader.h>

#include "systemitem.h"
//#include "mainwindow.h" temp

SystemItem::SystemItem() : WBlinkListBoxItem()
{
  KIconLoader *loader = kapp->getIconLoader();

  setText(i18n("System"));
  pm_last = loader->loadIcon("gray.xpm");
  pm_stat = loader->loadIcon("null.xpm");

  pmap_null = loader->loadIcon("null.xpm");
  pmap_auth = loader->loadIcon("auth.xpm");

  setPaintMode(VANISH);
  setPixmap(1,pmap_null);
  setPixmap(0,pmap_auth);
}

SystemItem::~SystemItem()
{
}

void SystemItem::paint(QPainter *p)
{
  QFont f = p->font();
  QFontMetrics fm = p->fontMetrics();

  if(isBlinkingFlag)
  {
    const QPixmap *pm_active = activePixmap();
    setPixmapXY(3, (QMAX(pm_active->height()+6, fm.lineSpacing())-pm_active->height())/2);
    WBlinkListBoxItem::paint(p);
  }
  else
  {
    p->drawPixmap(3, (QMAX(pm_last.height()+6, fm.lineSpacing())-pm_last.height())/2, pm_last);
    p->drawPixmap(3, (QMAX(pm_stat.height()+6, fm.lineSpacing())-pm_stat.height())/2, pm_stat);
  }

  int yPos;
  if (pm_last.height() < fm.height())
    yPos = fm.ascent() + fm.leading()/2;
  else
    yPos = (pm_last.height()+6)/2 - fm.height()/2 + fm.ascent();
  p->drawText(pm_last.width() + 7, yPos, text());
}

int SystemItem::height(const QListBox *lb ) const
{
  return QMAX(pm_last.height()+6, lb->fontMetrics().lineSpacing());
}

int SystemItem::width(const QListBox *lb ) const
{
  return pm_last.width() + lb->fontMetrics().width(text()) + 6;
}

const QPixmap *SystemItem::pixmap_last()
{
  return &pm_last;
}

const QPixmap *SystemItem::pixmap_stat()
{
  return &pm_stat;
}
