/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _USERLIST_
#define _USERLIST_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qlistbox.h>
#include <qlist.h>

#include "useritem.h"
#include "blinklistbox.h"

class icqMessage;

class UserList : public QListBox {
  Q_OBJECT
public:
  UserList(QWidget *parent=0, const char *name=0, WFlags f=0);
  ~UserList();
  UserItem *getItem(int);
  UserItem *getCurrent();
  int allCheck();
  void allChange();
  void setAllOnline(bool);
  bool getAllOnline() const;
  void allOffline();
  void changeList();
  void setBlinkingByUIN(unsigned long,int) ;

  void setBlinkInterval(int);
  void setBlinking(UserItem*, int);
  int blinkItemsCount();
protected:
  QPopupMenu *popup, *alertpopup, *specialoppopup;
  int oldCurrent;
  int doRemove;
  int recvRemove;
  int onlineID, visibleID;
  int allSetting;
  void paintCell(QPainter*, int, int);
  void mousePressEvent(QMouseEvent*);
  int getIndex(UserItem* bitem);

  int timerId;
  int blinkInterval;
  virtual void timerEvent(QTimerEvent*);
protected slots:
  void addRequest();
};
#endif
