/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: alertbox.cpp,v 1.1 2000/05/24 16:57:16 denis Exp $
// $Log: alertbox.cpp,v $
// Revision 1.1  2000/05/24 16:57:16  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.5  1999/12/02 13:56:39  denis
// Cleanups.
//
// Revision 1.4  1999/07/16 15:47:35  denis
// Cleaned up.
//
// Revision 1.3  1999/04/17 20:23:48  bills
// delete called in class instead of using auto-delete list for consistency
//
// Revision 1.2  1998/11/19 12:40:43  denis
// Default and Escape options added to Ok button
//

#include "alertbox.h"
#include "mainwindow.h"

#include "alertbox.moc"

AlertMsgBox::AlertMsgBox(unsigned long puin, const char *caption, const char *text) :
  QMessageBox(caption, text, QMessageBox::Information,
              QMessageBox::Ok | QMessageBox::Default | QMessageBox::Escape,
              0, 0, 0L, 0L, FALSE)
{
  auin = puin;
  setMinimumSize(200,100);
}


unsigned long AlertMsgBox::uin()
{
  return auin;
}

void AlertMsgBox::closeEvent(QCloseEvent *ce)
{
  QWidget::closeEvent(ce);
  MW->delAlertWin(this);
  delete this;
}

void AlertMsgBox::done(int)
{
  hide();
  MW->delAlertWin(this);
  delete this;
}
