/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: icqwindow.cpp,v 1.2 2000/06/17 17:01:35 denis Exp $
// $Log: icqwindow.cpp,v $
// Revision 1.2  2000/06/17 17:01:35  denis
// Cleanups.
//
// Revision 1.1  2000/05/24 16:57:16  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.6  2000/05/04 16:19:24  bills
// added requestComplete
//
// Revision 1.5  2000/01/10 16:08:25  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.4  1999/12/02 14:23:50  denis
// Random IcqWindow segfaults fixed.
//
// Revision 1.3  1999/07/23 12:30:59  denis
// Cleaned up.
//
// Revision 1.2  1999/07/16 15:48:05  denis
// Cleaned up.
//
// Revision 1.1  1999/04/17 20:16:57  bills
// added
//

#include <kapp.h>

#include "icqwindow.h"
#include "mainwindow.h"

#include "icqwindow.moc"

IcqWindow::IcqWindow(bool il) : QDialog()
{
  inList = il;
  if(inList)
    MW->addIcqWindow(this);
  sequence=0;
  m_requestComplete=false;
}

IcqWindow::~IcqWindow()
{
}

void IcqWindow::removeSelf()
{
  if(inList)
    MW->delIcqWindow(this);
}

void IcqWindow::requestNotify(int type, int length, void *data)
{
  if(type==ICQ_NOTIFY_SUCCESS && !m_requestComplete)
  {
    m_requestComplete=true;
    close();
  }
}

void IcqWindow::closeEvent(QCloseEvent *e)
{
  m_requestComplete=true;
  QDialog::closeEvent(e);
}

void IcqWindow::done(int r)
{
  QDialog::done(r);
  removeSelf();
}

bool IcqWindow::requestComplete()
{
  return m_requestComplete;
}
