/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _ICQWINDOW_
#define _ICQWINDOW_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qobject.h>
#include <qdialog.h>

class IcqWindow : public QDialog {
  Q_OBJECT
public:
  IcqWindow(bool il = TRUE);
  virtual ~IcqWindow();
  unsigned long seq() { return sequence; }
  // see icq.h for notification message types used by icqlib
  virtual void requestNotify(int type, int length, void *data);
  bool requestComplete();
protected:
  bool inList;
  unsigned long sequence;
  void removeSelf();
  virtual void closeEvent(QCloseEvent *e);
protected slots:
  virtual void done(int);
private:
  // set when request has completed, to indicate that no cleanup is
  // necessary (icqlib automatically cleans up when request is 
  // complete)
  bool m_requestComplete;
};

#endif /* _ICQWINDOW_ */
