/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _FILESNDWIN_
#define _FILESNDWIN_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qpushbt.h>
#include <qgrpbox.h>
#include <qdialog.h>
#include <qlined.h>
#include <qlabel.h>
#include <qmlined.h>

#include "icqwindow.h"

class FileSndWindow : public IcqWindow {
  Q_OBJECT
public:
  FileSndWindow(const char*, unsigned long, const char*);
  ~FileSndWindow();
  void setUIN(unsigned long);
  void setName(const char*);
  void setEMail(const char*);
  void stopCommand();
  void saveHistory();
  void requestNotify(int type, int length, void *data);
public slots:
signals:
protected:
  unsigned long uin;
  QString message;
  QPushButton *sendbutton, *cancelbutton, *selectbutton;
  QGroupBox *tobox;
  QLabel *uinlabel, *handlelabel, *emaillabel;
  QLineEdit *uinline, *handleline, *emailline;
  QPushButton *infobutton;
  QLabel *editlabel; /*, *urllabel; */
  QMultiLineEdit *editbox;
  char **files;
  /* QLineEdit *urlbox; */
  QLabel *updateanim;
  long sendSeq;
  void resizeEvent(QResizeEvent *);
protected slots:
  void sendFileReq();
  void cancelFileReq();
  void infoRequest();
  void selectFileReq();
private:
private slots:
};
#endif /* _FileSNDWIN_ */
