//
// $Id: icqfilesession.h,v 1.1 2000/05/24 16:57:49 denis Exp $
//
// Wrapper class for icqlib's icq_FileSession struct.
//
// $Log: icqfilesession.h,v $
// Revision 1.1  2000/05/24 16:57:49  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.1  2000/05/04 16:08:40  bills
// added
//
//

#ifndef _ICQFILESESSION_
#define _ICQFILESESSION_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qobject.h>
#include <qstrlist.h>

#include <icq.h>

class IcqFileSession : public QObject {

  Q_OBJECT

public:

  IcqFileSession(icq_FileSession *psession, QObject *parent = 0L,
    const char *name = 0L);

  ~IcqFileSession();

  void requestNotify(int type, int length, void *data);

  void setSpeed(int speed);
  void setWorkingDir(const QString &directory);
  void setFiles(const QStrList &files);
  
  void close();
  
  bool isTransferring() const;
  bool isSending() const;
  bool isReceiving() const;

  unsigned long remoteUIN() const;
  QString remoteHandle() const;

  int totalFiles() const;
  int currentFileNumber() const;
  unsigned long totalProgress() const;
  unsigned long totalSize() const;

  QString workingDir() const;
  QString currentFile() const;
  unsigned long currentFileSize() const;
  unsigned long currentFileProgress() const;

  int speed() const;

signals:

  void statusChanged(int status);
  void progress(unsigned long currentProgress, 
    unsigned long totalProgress);

private:

  icq_FileSession *m_session;

};

#endif // _FILESESSION_
