/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _HISTORYWIN_
#define _HISTORYWIN_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qpushbt.h>
#include <qchkbox.h>
#include <qlist.h>
#include <qlistview.h>
#include <ktabctl.h>

#include "icqmessage.h"
#include "recvwindow.h"
#include "icqwindow.h"

enum InOut { MSG_IN, MSG_OUT };

class AllEventsWidget : public QWidget
{
public:
  AllEventsWidget(QWidget *);
  void refresh(QList<icqMessage> *,int);
  int currentItem();
protected:
  QListView *msglist;
  void resizeEvent(QResizeEvent *);
};

class InOutEventsWidget : public QWidget
{
public:
  InOutEventsWidget(QWidget *,InOut);
  void refresh(QList<icqMessage> *,int);
  int currentItem();
protected:
  QListView *msglist;
  InOut direction;
  void resizeEvent(QResizeEvent *);
};

class HistoryWindow : public IcqWindow {
  Q_OBJECT
public:
  HistoryWindow(unsigned long);
  ~HistoryWindow();
  unsigned long UIN() const;
public slots:
  void refresh();
  void listSelected();
  void showDetail();
signals:
protected:
  unsigned long uin;
  int ascending, curtab;
  AllEventsWidget *allevents;
  InOutEventsWidget *inevents, *outevents;
  QPushButton *deletebtn;
  QCheckBox *orderbtn;
  QList<icqMessage> msgList;
  QList<RecvWindow> rwList;
  void readHistory();
protected slots:
  void changeTab(int);
  void closeCmd();
  void deleteCmd();
  void deleteAllCmd();
private:
private slots:
};

#endif /* _HISTORYWIN_ */
