/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _MLINELISTBOX_H
#define _MLINELISTBOX_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qpixmap.h>
#include <qfont.h>
#include <qpainter.h>
#include <qlistview.h>
#include <kapp.h>
#include <kiconloader.h>

class WMlineListBoxItem : public QListViewItem
{
public:
  WMlineListBoxItem(QListView*, int n = 255);
  void setText(int, const char*);
  void setPixmap(int, const QPixmap&);
  const char *key(int, bool) const { return ""; };
  void setup();
  void setOpen(bool);
protected:
  int showlines;

  void paintCell(QPainter*, const QColorGroup&, int, int, int);
  int totalHeight() const;
  virtual int width(const QFontMetrics&, const QListView*, int) const;
  int lines(int) const;
  const QString line(int,int) const;
};

#endif /* _MLINELISTBOX_H */
