/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: infomore.cpp,v 1.1 2000/05/24 16:58:18 denis Exp $
// $Log: infomore.cpp,v $
// Revision 1.1  2000/05/24 16:58:18  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.10  2000/01/10 16:08:32  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.9  1999/10/03 12:13:37  guruz
// Various Changes
//
// Revision 1.8  1999/10/02 12:35:44  guruz
// Changed some things in the KLineEditWithPopupMenu
// Made Homepage Info Line Edit Popup Menu
//
// Revision 1.7  1999/07/23 12:37:38  denis
// Layout management support implemented.
// Cleaned up.
//
// Revision 1.6  1999/07/16 15:48:13  denis
// Cleaned up.
//
// Revision 1.5  1999/07/16 13:11:21  denis
// Internalization support added.
//
// Revision 1.4  1998/12/08 16:18:01  denis
// Cleaned up a little before releasing
//

#include <stdlib.h> 
#include <qlayout.h>
#include <kapp.h>

#include "infomore.h"
#include "kurllineedit.h"

#include "infomore.moc"

MoreWidget::MoreWidget(QWidget *parent) : QWidget(parent)
{
  QGridLayout *topLayout = new QGridLayout(this, 7, 5, 0);
  topLayout->setRowStretch(0, 1);
  topLayout->setRowStretch(3, 1);
  topLayout->setRowStretch(6, 1);
  topLayout->setColStretch(1, 2);
  topLayout->setColStretch(3, 1);
  topLayout->addRowSpacing(0, 7);
  topLayout->addRowSpacing(3, 7);
  topLayout->addRowSpacing(6, 7);
  topLayout->addColSpacing(0, 7);
  topLayout->addColSpacing(2, 7);
  topLayout->addColSpacing(3, 50);
  topLayout->addColSpacing(4, 7);

  QLabel *hplabel = new QLabel(i18n("HomePage"),this);
  hplabel->setMinimumSize(hplabel->sizeHint());
  topLayout->addWidget(hplabel, 1, 1);

  QLabel *agelabel = new QLabel(i18n("Age"),this);
  agelabel->setMinimumSize(agelabel->sizeHint());
  topLayout->addWidget(agelabel, 1, 3);

  hpline = new KURLLineEdit(this);
  hpline->setFocusPolicy(QWidget::NoFocus);
  hpline->setMinimumSize(hpline->sizeHint());
  hpline->setMaximumHeight(hpline->sizeHint().height());
  topLayout->addWidget(hpline, 2, 1);

  ageline = new QLineEdit(this);
  ageline->setFocusPolicy(QWidget::NoFocus);
  ageline->setMinimumSize(50, ageline->sizeHint().height());
  ageline->setMaximumHeight(ageline->sizeHint().height());
  topLayout->addWidget(ageline, 2, 3);

  QLabel *phonelabel = new QLabel(i18n("Telephone Number"),this);
  phonelabel->setMinimumSize(phonelabel->sizeHint());
  topLayout->addWidget(phonelabel, 4, 1);

  QLabel *genderlabel = new QLabel(i18n("Gender"),this);
  genderlabel->setMinimumSize(genderlabel->sizeHint());
  topLayout->addWidget(genderlabel, 4, 3);

  phoneline = new QLineEdit(this);
  phoneline->setFocusPolicy(QWidget::NoFocus);
  phoneline->setMinimumSize(phoneline->sizeHint());
  phoneline->setMaximumHeight(phoneline->sizeHint().height());
  topLayout->addWidget(phoneline, 5, 1);

  genderline = new QLineEdit(this);
  genderline->setFocusPolicy(QWidget::NoFocus);
  genderline->setMinimumSize(50, genderline->sizeHint().height());
  genderline->setMaximumHeight(genderline->sizeHint().height());
  topLayout->addWidget(genderline, 5, 3);

  topLayout->activate();
}

void MoreWidget::setInfo(const char *php, unsigned int page, const char *pphone, const char *pgender)
{
  hpline->setText(php);
  QString pstr;
  page==0?pstr=i18n("Not Entered"):pstr.setNum(page);
  ageline->setText((const char*)pstr);
  phoneline->setText(strlen(pphone)==0?i18n("Not Entered"):pphone);
  genderline->setText(strlen(pgender)==0?i18n("Not Entered"):pgender);
}
