/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _INFOWINDOW_
#define _INFOWINDOW_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qpushbt.h>
#include <qdialog.h>
#include <qlabel.h>
#include <ktabctl.h>

#include "contactitem.h"
#include "icqwindow.h"

class MainWidget;
class AddrWidget;
class MoreWidget;
class AboutWidget;
class NotesWidget;

class InfoWindow : public IcqWindow {
  Q_OBJECT
public:
  InfoWindow(unsigned long);
  InfoWindow(ContactItem);
  void setMain(unsigned long, unsigned long, const char*, const char*, const char*, const char*);
  void setAddr(const char*, const char*, const char*, unsigned short, char, const char*);
  void setMore(const char*, unsigned int, const char*, const char*);
  void setAbout(const char*);
  void setNotes(const char*);
  void setInfo();
  unsigned long getUIN();
  void updateInfo(const char*, const char*, const char*, const char*, char);
  void updateExtInfo(const char*, unsigned short, char, const char*, unsigned short, char,
                     const char*, const char*, const char*);
  void stopCommand();
protected:
  unsigned long uin;
  ContactItem foreignInfo;
  KTabCtl *tabctl;
  MainWidget *mainwidget;
  AddrWidget *addrwidget;
  MoreWidget *morewidget;
  AboutWidget *aboutwidget;
  NotesWidget *noteswidget;
  QPushButton *donebtn, *updatebtn;
  QLabel *updateanim;
  int local;
  char upd_count;

  void initLayout();
protected slots:
  void doneCommand();
  void updateCommand();
};
#endif /* _INFOWINDOW_ */
