/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: main.cpp,v 1.11 2000/07/24 18:59:54 denis Exp $
// $Log: main.cpp,v $
// Revision 1.11  2000/07/24 18:59:54  denis
// Patch by Ben Reser <breser@users.sourceforge.net> for signal handling
// was applied.
//
// Revision 1.10  2000/01/10 16:08:43  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.9  1999/12/02 14:25:27  denis
// Session management enabled.
//
// Revision 1.8  1999/07/16 15:48:19  denis
// Cleaned up.
//
// Revision 1.7  1999/07/16 13:11:33  denis
// Internalization support added.
//
// Revision 1.6  1999/07/12 15:23:25  cproch
// - changed icq_* function calls and callback function to support
//   icqlib with ICQLINK identifier.
// - look for FIXME in mainwindow.cpp
//
// Revision 1.5  1999/03/24 11:52:45  denis
// Some work on command line options started
//
// Revision 1.4  1998/12/08 16:19:01  denis
// Cleaned up a little before releasing
//

#include <kapp.h>
#include <signal.h>

#include "mainwindow.h"

void sighup_handler(int sighup)
{
  MW->setStatus(stOffline);
}

void sigusr1_handler(int sigusr1)
{
  MW->setStatus(stOnline);
}

int main(int argc, char *argv[])
{
  int i;
  KApplication app(argc, argv, "kicq");

  icq_LogLevel = 10;

  // TODO: Move it before [KQ]Application constructor to avoid
  // X11 connection initialization (for example -help option)
  if(app.argc()>1)
  {
    for(i=1; i<=app.argc(); i++)
    {
      if(!strcmp(app.argv()[i], "-help"))
      {
        printf(i18n("Help! I need somebody help!\n"));
        return 0;
      }
    }
  }

  MainWindow *win = new MainWindow();

  app.setMainWidget(win);

  signal(SIGHUP, sighup_handler);
  signal(SIGUSR1, sigusr1_handler);

  kapp->enableSessionManagement();

  int ret = app.exec();
  delete win;
  return ret;
}
