/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: mainwindow.cpp,v 1.83 2000/07/30 18:55:31 denis Exp $
// $Log: mainwindow.cpp,v $
// Revision 1.83  2000/07/30 18:55:31  denis
// Warnings were fixed.
//
// Revision 1.82  2000/07/28 18:28:43  denis
// More debug requests were added for testing purposes.
//
// Revision 1.81  2000/07/25 17:21:06  denis
// When no registered users were found in the system on startup,
// open Registration Wizard.
//
// Revision 1.80  2000/07/24 19:04:03  denis
// ICQ button animation was implemented!
//
// Revision 1.79  2000/07/24 04:01:06  bills
// added nick to icq_init call
//
// Revision 1.78  2000/07/11 18:13:29  denis
// Debug messages were removed.
// Some cleanups.
//
// Revision 1.77  2000/07/10 14:54:54  pcadach
// Store registration information when new user registered.
//
// Revision 1.76  2000/07/10 09:24:25  pcadach
// Recording of first-time registration information updated. See ChangeLog.
//
// Revision 1.75  2000/07/09 18:59:09  denis
// Multi-owner feature was added.
// Note: move your ~/.kde/share/config/kicqrc to
// ~/.kde/share/apps/kicq/owners/<UIN>.conf and create
// ~/.kde/share/config/kicqrc with section [Owner] and key UIN=<UIN>
// where <UIN> is your current UIN (ICQ#) -- kicq-upgrade.sh will changed
// later.
//
// Revision 1.74  2000/06/25 18:07:02  denis
// Debug requests from main menu were #ifdef-ed.
// Close contact list and disconnect when going to register new user.
//
// Revision 1.73  2000/06/17 16:49:36  denis
// Whole mainwindow.cpp was splitted for several smaller files:
// mainconfig.cpp, specialops.cpp and, of course, mainwindow.cpp
//
// Revision 1.72  2000/05/24 16:56:34  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.71  2000/05/11 12:15:15  denis
// Actually call icq_Disconnect() on disconnect and close sockets.
//
// Revision 1.70  2000/05/10 19:24:00  denis
// UDP outgoing packet queue was implemented.
// Possible buffer overflow fixed.
// Some cleanups.
//
// Revision 1.69  2000/05/06 18:16:55  denis
// Contact list have been moved to the owner specific location:
//   from ~/.kde/share/apps/kicq/contacts
//   to   ~/.kde/share/apps/kicq/contacts.<UIN>
// Small typo was fixed.
//
// Revision 1.68  2000/05/05 03:39:09  bills
// commented out debug menu item in main icq menu, fixed bug in
// updateBlinking where incorrect icon would be displayed on first blink,
// added correct icon for MSG_FILE_REQ_RECV.
//
// Revision 1.67  2000/05/04 16:13:37  bills
// removed debugging printfs.
//
// Revision 1.66  2000/05/04 15:41:25  denis
// Callbacks moved to the ICQLINK structure.
// Some RegWindow helper code.
//
// Revision 1.65  2000/04/10 14:16:44  denis
// Fixed segfault when some bogus UIN have changed its status.
//
// Revision 1.64  2000/04/04 17:19:23  denis
// Applied patch from Maxim Dmitrichenko <dmax@nix.com.ua> for All/Online
// toggle button with some modifications like transparency in icons and
// save/restore its state in config file.
//
// Revision 1.63  2000/03/30 15:39:34  denis
// Fixed FreeBSD specific compilation error on netinet/in.h header.
//
// Revision 1.62  2000/03/30 15:10:50  denis
// Null password bug fixed.
//
// Revision 1.61  2000/03/01 20:48:29  guruz
// -Added WGet as browser when recieving URLs
// -Modified server prefs
// -fixed some things with special ops
//
// Revision 1.60  2000/01/20 20:03:03  bills
// initial implementation for sending file requests
//
// Revision 1.59  2000/01/10 16:08:44  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.58  1999/12/28 15:56:11  denis
// Reverse IP in Special Options fixed.
//
// Revision 1.57  1999/12/28 01:48:02  bills
// changed tcp timer to 100ms for file transfer, added new code for file transfers
//
// Revision 1.56  1999/12/12 18:08:41  denis
// Existing kapp->topWidget()'s chnaged to MW macros.
//
// Revision 1.55  1999/12/02 15:06:43  denis
// Session management implemented.
// Try to fix Authorization request problems.
// WebPager and EMailExpress messages handlers implemented.
// One big saveConfig() spletted to many specific saveConfig*().
// New egcs compilation warnings fixed.
// Cleanups.
//
// Revision 1.54  1999/11/29 21:24:39  guruz
// Some new features in the user list context menu
// I hope it all REALLY works because i cannot test it
// properly because of the damn online users bug
//
// Revision 1.53  1999/11/21 18:55:35  guruz
// Added "Send E-Mail" in User List Context Menu
//
// Revision 1.52  1999/11/11 15:10:34  guruz
// - Added Base for Webpager Messages. Please type "make fixme"
// - Removed Segfault when kicq is started the first time
//
// Revision 1.51  1999/10/22 17:43:10  guruz
// Password Encryption in kicqrc
//
// Revision 1.50  1999/10/15 16:56:35  guruz
// Various
//
// Revision 1.49  1999/10/14 13:01:45  denis
// Cleanups.
//
// Revision 1.48  1999/10/08 10:38:46  guruz
// Removed some crap i made
//
// Revision 1.47  1999/10/07 18:22:21  denis
// Commented out <linux/kd.h> - it's linux specific.
//
// Revision 1.46  1999/10/06 19:13:32  denis
// Fixed "kicq exit on a new message" bug. LED code is broken.
//
// Revision 1.45  1999/10/05 19:00:35  guruz
// -Added Message Timeout Patch by kyle@13th-floor.org
// -Fixed bug in wrapedit.cpp
//
// Revision 1.44  1999/10/05 14:10:54  guruz
// -Base for a send window that allows to insert predefined phrases
// -Fixed Copy IP To Clipboard
//
// Revision 1.43  1999/10/04 19:15:58  guruz
// -Added "make fixme"
// -The URL Edits are now a bit better
// -The Browser Tab of the Preferences window has another caption
//
// Revision 1.42  1999/10/03 19:07:39  guruz
// There is now the possibility to open URLs that are in the URL Line Edits !
//
// Revision 1.41  1999/10/03 12:13:39  guruz
// Various Changes
//
// Revision 1.40  1999/09/29 17:41:13  denis
// Segmentation fault on startup fixed.
// Markus Goetz <guruz@gmx.de> patches applied.
// kyle@13th-floor.org auto-away patch applied.
//
// Revision 1.39  1999/07/19 13:15:00  tim
// - added support for MSG_ADDED_RECV ("you were added to contact list")
//
// Revision 1.38  1999/07/18 20:29:33  bills
// changed to use new contact list functions
//
// Revision 1.37  1999/07/16 15:48:20  denis
// Cleaned up.
//
// Revision 1.36  1999/07/16 13:26:40  denis
// i18n support added.
//
// Revision 1.35  1999/07/12 15:23:26  cproch
// - changed icq_* function calls and callback function to support
//   icqlib with ICQLINK identifier.
// - look for FIXME in mainwindow.cpp
//
// Revision 1.34  1999/05/04 00:05:46  bills
// added .wav file sound support!
//
// Revision 1.33  1999/04/17 20:24:28  bills
// changed multiple window lists into single window list (except for alert
// windows)
//
// Revision 1.32  1999/04/14 15:36:42  denis
// Cleanups.
//
// Revision 1.31  1999/04/04 22:04:00  bills
// added support for MSG_CHAT_REQ_RECV and chat window handling
//
// Revision 1.30  1999/03/31 01:28:04  bills
// modified userOnline function to include tcpflag
//
// Revision 1.29  1999/03/28 02:00:10  bills
// added tcptimer for icq_TCPMain
//
// Revision 1.28  1999/03/24 11:56:42  denis
// Cleaned up a little
//
// Revision 1.27  1999/03/16 01:09:19  tim
// Cleanup authorize code.
//
// Revision 1.26  1999/03/09 13:17:23  denis
// ICQ Registration Wizard was started
//
// Revision 1.25  1999/03/05 13:04:39  denis
// Applied patch to handle authorization request messages by Bogdan Surdu
// <tim@ima-info.ro>
//
// Revision 1.24  1998/12/11 18:22:01  whale
// Added support for MSG_AUTH_RECV (incoming auth requests)
//
// Revision 1.23  1998/12/08 16:22:58  denis
// getFirstUnreadMsgUIN method added
// setToolTip with updateBlinking methods added
// Reconnect on disconnect preference option added
// Cleaned up a little before releasing
//
// Revision 1.22  1998/11/25 19:17:23  denis
// Hopefully fixed icq_HandleProxyResponse bug
//
// Revision 1.21  1998/11/25 17:47:56  denis
// QSocketNotifier for proxy socket fixed, I hope
// Commented out previous fix

#include <sys/types.h>  // * FreeBSD note: 
#include <sys/socket.h> // * This headers
#include <arpa/inet.h>  // * should be in
#include <netinet/in.h> // * this order.
#include <sys/stat.h>  // for mkdir()
#include <unistd.h>    // for unlink()
#include <iostream.h>
#include <icq.h>
#include <qdir.h>
#include <qtimer.h>
#include <qclipboard.h> // for QClipboard::SetText();
#include <qmsgbox.h>
#include <qstrlist.h>
#include <qregexp.h>
#include <kapp.h>
#include <kiconloader.h>
#include <kwm.h>

#include "mainwindow.h"
#include "xautolock.h"
#include "regwin.h"
#include "chatwindow.h"
#include "kwebbrowser.h"
#include "specialops.h"
#include "userlist.h"
#include "systembar.h"
#include "preferences.h"
#include "findwindow.h"
#include "infowindow.h"
#include "msgwindow.h"
#include "recvwindow.h"
#include "docking.h"
#include "urlsndwin.h"
#include "renwindow.h"
#include "historywin.h"
#include "chatsndwin.h"
#include "filesndwin.h"
#include "icqsound.h"
#include "icqanimbutton.h"

#include "mainwindow.moc"

#undef DEBUG_REQUEST
//#define DEBUG_REQUEST 1

extern "C" char *inet_ntoa(struct in_addr in);

QString MainWindow::intIP2StringIP(unsigned long intIP)
{
  QString temp;
  char *buf;
  struct in_addr in;
  in.s_addr = ntohl(intIP);
  buf = inet_ntoa(in);
  temp.setStr(buf);
  return temp;
}

MainWindow::MainWindow() : KTopLevelWidget()
{
//  registerCommand();

  KIconLoader *il = kapp->getIconLoader();
  resize(150,250);
  setMinimumSize(150,250);
  panelwidget = new QWidget(this);
  setView(panelwidget);
  listwidget = new UserList(panelwidget);

  statemenu = new QPopupMenu();
  statemenu->insertItem(il->loadIcon("online.xpm"),i18n("Online/Connect"),stOnline);
  statemenu->insertItem(il->loadIcon("away.xpm"),i18n("Away"),stAway);
  statemenu->insertItem(il->loadIcon("na.xpm"),i18n("N/A (Extended Away)"),stNA);
  statemenu->insertItem(il->loadIcon("occupied.xpm"),i18n("Occupied (Urgent Msgs)"),stOccupied);
  statemenu->insertItem(il->loadIcon("dnd.xpm"),i18n("DND (Do not Disturb)"),stDND);
  statemenu->insertItem(il->loadIcon("privacy.xpm"),i18n("Privacy (Invisible)"),stInvisible);
  statemenu->insertItem(il->loadIcon("freechat.xpm"),i18n("Free for Chat"),stFFC);
  statemenu->insertItem(il->loadIcon("offline.xpm"),i18n("Offline/Disconnect"),stOffline);
  statemenu->setMouseTracking(TRUE);
  connect(statemenu, SIGNAL(activated(int)), SLOT(setStatus(int)));

  dockwidget = new DockWidget();
  dockwidget->setIcon(il->loadIcon("offline.xpm")); // Why this doesn't work???
  dockwidget->dock();
  connect(dockwidget, SIGNAL(quitClicked()), this, SLOT(quitRequest()));

  allbutton = new QToolButton(panelwidget);
  allbutton->setIconSet(il->loadIcon("all.xpm"));
  allbutton->setToggleButton(TRUE);
  connect(allbutton, SIGNAL(clicked()), SLOT(allCommand()));

  addbutton = new QPushButton(i18n("Search/Add Users"),panelwidget);
  connect(addbutton, SIGNAL(clicked()), SLOT(addCommand()));

  syswidget = new SystemBar(panelwidget);

//  menubutton = new QPushButton(i18n("ICQ"),panelwidget);
  menubutton = new IcqAnimButton(panelwidget);
  connect(menubutton, SIGNAL(clicked()), SLOT(menuCommand()));
  statebutton = new ConnectButton(panelwidget);
  connect(statebutton, SIGNAL(clicked()), SLOT(stateCommand()));

  appdir = kapp->localkdedir()+"/share/apps";
  if(!QDir(appdir).exists())
    mkdir((const char*)appdir,0700);
  appdir += "/" + kapp->appName();
  if(!QDir(appdir).exists())
    mkdir((const char*)appdir,0700);
  QString ownersdir = appdir + "/owners";
  if(!QDir(ownersdir).exists())
    mkdir((const char*)ownersdir,0700);

  icqmenu = new QPopupMenu();
  icqmenu->insertItem(il->loadIcon("search.xpm"),i18n("Search/Add Users"),this,SLOT(addCommand()));
  icqmenu->insertSeparator();
#ifdef DEBUG_REQUEST
  icqmenu->insertItem("debug1Request", this, SLOT(debug1Request()));
  icqmenu->insertItem("debug2Request", this, SLOT(debug2Request()));
  icqmenu->insertItem("debug3Request", this, SLOT(debug3Request()));
  icqmenu->insertItem("debug4Request", this, SLOT(debug4Request()));
  icqmenu->insertItem("debug5Request", this, SLOT(debug5Request()));
  icqmenu->insertItem("debug6Request", this, SLOT(debug6Request()));
  icqmenu->insertItem("debug7Request", this, SLOT(debug7Request()));
#endif
//  icqmenu->insertItem(il->loadIcon("setup.xpm"),i18n("Security / Privacy"),MENU_SECURITY);
  icqmenu->insertItem(il->loadIcon("setup.xpm"),i18n("Preferences"),MENU_PREFERENCES);
  icqmenu->insertSeparator();
  ownersmenu = new QPopupMenu();
  icqmenu->insertItem(i18n("New User"),this,SLOT(registerCommand()));
  icqmenu->insertItem(i18n("Change User"), ownersmenu);
  icqmenu->insertSeparator();
  icqmenu->insertItem(il->loadMiniIcon("klipper.xpm"),i18n("Copy my UIN to clipboard"),
                      MENU_COPYUINTOCLIPBOARD);
  icqmenu->insertItem(il->loadMiniIcon("klipper.xpm"),i18n("Copy my IP Address to clipboard"),
                      MENU_COPYIPTOCLIPBOARD);
  icqmenu->insertSeparator();
  icqmenu->insertItem(il->loadIcon("shutdown.xpm"),i18n("Shut Down"),MENU_SHUTDOWN);
  icqmenu->setMouseTracking(TRUE);
  connect(icqmenu, SIGNAL(activated(int)), SLOT(icqCommand(int)));

  blinkPixmap[0] = il->loadIcon("message.xpm");
  blinkPixmap[1] = il->loadIcon("null.xpm");
  blinkFlag = 0;

  connect(kapp, SIGNAL(saveYourself()), this, SLOT(saveSessionConfig()));

  sound = new IcqSound;

  libTimer = new QTimer(this);
  connect(libTimer, SIGNAL(timeout()), this, SLOT(libTimerDone()));

  prefwin = new Preferences();
  prefwin->setDefault();
  if(!checkConfig())
  {
    regwin = new RegWindow(0L);
    if(regwin->exec()==QDialog::Rejected)
      exit(1);
    delete regwin;
    regwin = 0L;
  }

  icqWinList.setAutoDelete(FALSE);

  findwin = new FindWindow();

  regwin = 0L;
  logged = FALSE;
  log_status = stOffline;
  socketnotifier = 0L;
  proxynotifier = 0L;
  keepalivetimer = -1;
  tcptimer = -1;
  autoawaytimer = -1;

  startOwner();

  MW->sound->soundEvent("Startup");
}

MainWindow::~MainWindow()
{
  if(socketnotifier)
    delete socketnotifier;
  if(proxynotifier)
    delete proxynotifier;
  if(findwin)
    delete findwin;
  if(prefwin)
    delete prefwin;
  if(listwidget)
    delete listwidget;
  if(addbutton)
    delete addbutton;
  if(allbutton)
    delete allbutton;
  if(syswidget)
    delete syswidget;
  if(menubutton)
    delete menubutton;
  if(statebutton)
    delete statebutton;
  if(statemenu)
  {
    statemenu->clear();
    delete statemenu;
  }
  if(icqmenu)
  {
    icqmenu->clear();
    delete icqmenu;
  }
  if(panelwidget)
    delete panelwidget;
  if(dockwidget)
    delete dockwidget;
  if(sound)
    delete sound;
}

void MainWindow::prepareNewUIN(unsigned long u)
{
  setOwnerConfigUIN(u);
  startOwner();
}

void MainWindow::startOwner()
{
  icqStatus st = loadConfig();

  QString spwd = passwd.left(8);
  if(spwd.isNull())
    spwd = "";
  icq_Init(&icqlink, uin, (const char*)spwd, (const char*)nick);

  setupGUICallbacks();

  setTitle();

  fillOwnersPopup();

  contdir.sprintf("%s/contacts.%lu", (const char*)appdir, uin);
  if(!QDir(contdir).exists())
    mkdir((const char*)contdir,0700);

  contactlist.load(contdir);

  setStatus(st);
}

void MainWindow::libTimerDone()
{
  icq_HandleTimeout(&icqlink);
}

void MainWindow::autoAway()
{
  if(!autoawayenabled)
  {
    return;
  }
  int move;
  if(checkTimeOut(move))
  {
    if((cur_status == stOnline) || (cur_status == stFFC))
    {
      setStatus(stAway); // set away
      autoawayset = true;
      initTimeOut(autoawaytimeout * 60); // set auto-away timeout
    }
    else if((cur_status == stAway) && (autoawayset || autoawaytona))
    {
      setStatus(stNA); // set NA
      initTimeOut(autonatimeout * 60); // if away for more than, set NA
    }
  }
  if(move && ((cur_status == stNA) || (cur_status == stAway)) && autoawayset)
  {
    setStatus(stOnline); // set online
    autoawayset = false;
    initTimeOut(autoawaytimeout * 60); // set auto-away timeout
  }
}

void MainWindow::setTitle()
{
  QString title;
  title.setNum(uin);
  setCaption(title);
}

void MainWindow::closeEvent(QCloseEvent*)
{
/* Until we don't know how to get "minimize window" event
   MainWindow will be docked on "close window" event */
/*  KTopLevelWidget::closeEvent(e);
  quitRequest();*/
  dockwidget->hideWindow();
}

void MainWindow::resizeEvent(QResizeEvent *re)
{
  KTopLevelWidget::resizeEvent(re);
  menubutton->setGeometry(0,panelwidget->height()-23,51,23);
  statebutton->setGeometry(53,panelwidget->height()-23,panelwidget->width()-53,23);
  syswidget->setGeometry(0,menubutton->y()-syswidget->itemHeight(0)-6,
                         panelwidget->width(),syswidget->itemHeight(0)+4);
  addbutton->setGeometry(0,syswidget->y()-22,panelwidget->width(),20);
  allbutton->setGeometry(0,0,25,25);
  listwidget->setGeometry(0,25,panelwidget->width(),addbutton->y()-27);
}

void MainWindow::menuCommand()
{
  icqmenu->move(-1000,-1000);
  icqmenu->show();
  QPoint pos = menubutton->mapToGlobal(QPoint(0,0));
  pos.setY(pos.y()-icqmenu->height());
  icqmenu->popup(pos);
}

void MainWindow::stateCommand()
{
  statemenu->move(-1000,-1000);
  statemenu->show();
  QPoint pos = statebutton->mapToGlobal(QPoint(0,0));
  pos.setY(pos.y()-statemenu->height());
  statemenu->popup(pos);
}

void MainWindow::quitRequest()
{
  saveProperties();
  saveStatus();
  setStatus(stOffline);
  kapp->quit();
}

void MainWindow::icqCommand(int num)
{
  QString temp;
  switch(num)
  {
    case MENU_SHUTDOWN:
      quitRequest();
      break;
    case MENU_PREFERENCES:
      prefwin->setOwner(uin,nick,passwd);
      prefwin->setServer(server,port);
      prefwin->setProxy(useproxy, proxyhost, proxyport, proxyauth, proxyuser, proxypass);
      prefwin->setLogging(icq_LogLevel, logfile);
      prefwin->setSound(playWav);
      prefwin->setOther(icq_Russian, closeRecv, convertCRLF, quote, reconnect);
      prefwin->setAway(autoawaytimeout, autonatimeout, autoawayenabled, autoawaytona);
      if(prefwin->exec()==QDialog::Accepted)
      {
        loadConfig();
        setTitle();
      }
      break;
    case MENU_SECURITY:
      break;
    case MENU_COPYUINTOCLIPBOARD:
      temp.setNum(uin);
      kapp->clipboard()->setText(temp);
      break;
    case MENU_COPYIPTOCLIPBOARD:
      temp = intIP2StringIP(MW->icqlink.icq_OurIP);
      kapp->clipboard()->setText(temp);
      break;
  }
}

void MainWindow::recvRequest()
{
  if(listwidget->currentItem()>=0)
    recvRequest(listwidget->currentItem());
}

void MainWindow::recvRequest(int num)
{
  UserItem *usritem = listwidget->getItem(num);
  if(!usritem->canBeSelected())
    return;

  /* If we have any new messages here, we must show them */
  /* otherwise display new message window */
  if(contactList().getNumUnreadMsgsByUIN(usritem->getUIN()) != 0)
  {
    IcqWindow *ptr;
    RecvWindow *recvwin=0L;

    for(ptr = icqWinList.first(); ptr != 0L; ptr = icqWinList.next())
    {
      if(ptr->inherits("RecvWindow"))
      {
        RecvWindow *precv=(RecvWindow*)ptr;
        if(precv->UIN() == usritem->getUIN())
          recvwin = precv;
      }
    }

    if(!recvwin)
    {
      QList<icqMessage> *l = contactList().getMsgListByUIN(usritem->getUIN());
      recvwin =
        new RecvWindow(l, l->count() - contactList().getNumUnreadMsgsByUIN(usritem->getUIN()),
                       usritem->getUIN(),TRUE);
      recvwin->show();
    }
    else
      recvwin->raise();
  }
  else
    messageRequest(num);
}

void MainWindow::messageRequest()
{
  if(listwidget->currentItem()>=0)
    messageRequest(listwidget->currentItem());
}

void MainWindow::messageRequest(int num)
{
  unsigned long uin = listwidget->getItem(num)->getUIN();
  MsgWindow *msgwin = new MsgWindow(contactList().getNickByUIN(uin), uin,
                                    contactList().getEMailByUIN(uin), 0L);
  msgwin->show();
}

void MainWindow::messageRequest(unsigned long uin, const char *msg)
{
  const ContactItem *item = contactList().getInfoByUIN(uin);
  if(item)
  {
    MsgWindow *msgwin = new MsgWindow(item->getNick(), item->getUIN(), item->getEMail(), msg);
    msgwin->show();
  }
}

void MainWindow::chatRequest()
{
  if(listwidget->currentItem()>=0)
    chatRequest(listwidget->currentItem());
}

void MainWindow::chatRequest(int num)
{
  unsigned long uin = listwidget->getItem(num)->getUIN();
  ChatSndWindow *chatwin = new ChatSndWindow(contactList().getNickByUIN(uin), uin,
                                             contactList().getEMailByUIN(uin));
  chatwin->show();
}

void MainWindow::fileRequest()
{
  if(listwidget->currentItem()>=0)
    fileRequest(listwidget->currentItem());
}

void MainWindow::fileRequest(int num)
{
  unsigned long uin = listwidget->getItem(num)->getUIN();
  FileSndWindow *filewin = new FileSndWindow(contactList().getNickByUIN(uin), uin,
                                             contactList().getEMailByUIN(uin));
  filewin->show();
}

void MainWindow::urlRequest()
{
  if(listwidget->currentItem()>=0)
    urlRequest(listwidget->currentItem());
}

void MainWindow::urlRequest(int num)
{
  unsigned long uin = listwidget->getItem(num)->getUIN();
  URLSndWindow *urlwin = new URLSndWindow(contactList().getNickByUIN(uin), uin,
                                          contactList().getEMailByUIN(uin));
  urlwin->show();
}

void MainWindow::authRequest()
{
  if(listwidget->currentItem()>=0)
    authRequest(listwidget->currentItem());
}

void MainWindow::authRequest(int num)
{
  icq_SendAuthMsg(&icqlink, listwidget->getItem(num)->getUIN());
}

void MainWindow::historyRequest()
{
  if(listwidget->currentItem()>=0)
    historyRequest(listwidget->currentItem());
}

void MainWindow::historyRequest(int num)
{
  unsigned long uin = listwidget->getItem(num)->getUIN();
  HistoryWindow *hwin = new HistoryWindow(uin);
  hwin->show();
}

void MainWindow::readFirstRequest()
{
  unsigned int i;
  for(i=0; i<listwidget->count(); i++)
  {
    UserItem *ptr = listwidget->getItem(i);
    if(ptr->canBeSelected())
      if(contactList().getNumUnreadMsgsByUIN(ptr->getUIN()))
      {
        recvRequest(i);
        return;
      }
  }
}

void MainWindow::addCommand()
{
  findwin->show();
  findwin->raise();
}

void MainWindow::setAllOnline(bool allSet)
{
  KIconLoader *il = kapp->getIconLoader();

  listwidget->setAllOnline(allSet);
  if(listwidget->getAllOnline())
  {
    allbutton->setIconSet(il->loadIcon("all.xpm"));
    allbutton->setOn(FALSE);
  }
  else
  {
    allbutton->setIconSet(il->loadIcon("notall.xpm"));
    allbutton->setOn(TRUE);
  }
  allbutton->update();
}

bool MainWindow::getAllOnline()
{
  return listwidget->getAllOnline();
}

void MainWindow::allCommand()
{
  listwidget->allChange();
  setAllOnline(getAllOnline());
  updateVisibleList();
}

void MainWindow::registerCommand()
{
  setStatus(stOffline);
  dockwidget->hideWindow();
  regwin = new RegWindow(0L);
  regwin->exec();
  delete regwin;
  regwin = 0L;
}

void MainWindow::debug1Request()
{
  if(listwidget->currentItem() < 0)
    return;

  unsigned long uin = listwidget->getCurrent()->getUIN();
//  icq_SendMetaInfoReq(&icqlink, uin);
  message(&icqlink, uin, 22, 45, 19, 10, 1998, "Test message\n");
//  userOnline(uin, STATUS_ONLINE, 0x0a0a0a0a, 0, 0);
}

void MainWindow::debug2Request()
{
  if(listwidget->currentItem() < 0)
    return;

  unsigned long uin = listwidget->getCurrent()->getUIN();
  url(&icqlink, uin, 22, 45, 19, 10, 1998, "http://kicq.sourceforge.net", "kicq home page");
//  userOffline(usritem->UIN());
}

void MainWindow::debug3Request()
{
  if(listwidget->currentItem() < 0)
    return;

  unsigned long uin = listwidget->getCurrent()->getUIN();
  added(&icqlink, uin, 22, 45, 19, 10, 1998, "nick", "first", "last", "email");
}

void MainWindow::debug4Request()
{
  if(listwidget->currentItem() < 0)
    return;

  unsigned long uin = listwidget->getCurrent()->getUIN();
  authreq(&icqlink, uin, 22, 45, 19, 10, 1998, "nick", "first", "last", "email", "testing...");
}

void MainWindow::debug5Request()
{
  if(listwidget->currentItem() < 0)
    return;

  unsigned long uin = listwidget->getCurrent()->getUIN();
  chatReq(&icqlink, uin, 22, 45, 19, 10, 1998, "testing...", 1);
}

void MainWindow::debug6Request()
{
  if(listwidget->currentItem() < 0)
    return;

  unsigned long uin = listwidget->getCurrent()->getUIN();
  fileReq(&icqlink, uin, 22, 45, 19, 10, 1998, "testing...", "testfile.txt", 1234567, 1);
}

void MainWindow::debug7Request()
{
  if(listwidget->currentItem() < 0)
    return;

  unsigned long uin = listwidget->getCurrent()->getUIN();
  mailExpress(&icqlink, 22, 45, 19, 10, 1998, "nick", "email", "testing...");
}

void MainWindow::userOnline(ICQLINK *link, unsigned long uin, unsigned long status,
                            unsigned long ip, unsigned short port, unsigned long r_ip,
                            unsigned char tcp_flag)
{
  if(MW->contactList().isUINInContactList(uin))
  {
    MW->contactList().userOnlineByUIN(uin, status, ip, port, r_ip, tcp_flag);
    if(MW->contactList().getOnlineAlertByUIN(uin))
      MW->addAlertWin(uin);
  }
}

void MainWindow::userStatusUpdate(ICQLINK *link, unsigned long uin, unsigned long status)
{
  MW->contactList().setStatusByUIN(uin, status);
}

void MainWindow::userOffline(ICQLINK *link, unsigned long uin)
{
  MW->contactList().setStatusByUIN(uin, (unsigned long)STATUS_OFFLINE);
}

void MainWindow::infoRequest()
{
  if(listwidget->currentItem() >= 0)
    infoWindow(listwidget->getCurrent()->getUIN());
}

void MainWindow::infoWindow(unsigned long uin)
{
  InfoWindow *infowin = 0L;
  IcqWindow *ptr;

  for(ptr = icqWinList.first(); ptr != 0L; ptr = icqWinList.next())
  {
    if(ptr->inherits("InfoWindow"))
    {
      InfoWindow *pinfo=(InfoWindow*)ptr;
      if(pinfo->getUIN() == uin)
        infowin = pinfo;
    }
  }
  if(!infowin)
    infowin = new InfoWindow(uin);
  infowin->show();
  infowin->raise();
}

void MainWindow::infoWindow(ContactItem info)
{
  InfoWindow *infowin = 0L;
  IcqWindow *ptr;

  for(ptr = icqWinList.first(); ptr != 0L; ptr = icqWinList.next())
  {
    if(ptr->inherits("InfoWindow"))
    {
      InfoWindow *pinfo=(InfoWindow*)ptr;
      if(pinfo->getUIN() == info.getUIN())
        infowin = pinfo;
    }
  }

  if(!infowin)
    infowin = new InfoWindow(info);
  infowin->show();
  infowin->raise();
}

void MainWindow::onlineAlert()
{
  if(listwidget->currentItem() < 0)
    return;

  contactList().toggleOnlineAlertByUIN(listwidget->getCurrent()->getUIN());
  updateVisibleList();
}

void MainWindow::visibleUser()
{
  if(listwidget->currentItem() < 0)
    return;

  contactList().toggleVisibleUserByUIN(listwidget->getCurrent()->getUIN());
  if(logged)
    icq_SendVisibleList(&icqlink);
  updateVisibleList();
}

void MainWindow::renameRequest()
{
  if(listwidget->currentItem() < 0)
    return;

  unsigned long uin = listwidget->getCurrent()->getUIN();

  if(!contactList().isUINInContactList(uin))
    return;

  RenameWindow *renwin = 0L;
  IcqWindow *ptr;

  for(ptr = icqWinList.first(); ptr != 0L; ptr = icqWinList.next())
  {
    if(ptr->inherits("RenameWindow"))
    {
      RenameWindow *pren=(RenameWindow*)ptr;
      if(pren->UIN() == uin)
        renwin = pren;
    }
  }

  if(renwin)
  {
    renwin->raise();
    return;
  }

  const ContactItem *item = contactList().getInfoByUIN(uin);
  if(!item)
    return;

  renwin = new RenameWindow(item->getName(), uin, item->getNick(), item->getFirstName(),
                            item->getLastName(), item->getEMail());
  renwin->show();
}

void MainWindow::delUserRequest()
{
  if(listwidget->currentItem() <0)
    return;

  UserItem *usritem = listwidget->getCurrent();
  QString tmp;
  unsigned long uin = usritem->getUIN();
  tmp.sprintf(i18n("Are you sure you want to delete\nuser %s with ICQ# %lu?"),
              (const char*)contactList().getNickByUIN(uin), uin);
  if(QMessageBox::warning(this, i18n("Confirm"), tmp, QMessageBox::Yes,
                          QMessageBox::No | QMessageBox::Default |
                          QMessageBox::Escape) != QMessageBox::Yes)
    return;

  if(usritem->isBlinking())
    listwidget->setBlinkingByUIN(uin, FALSE);

  if(contactList().isUINNotInList(uin))
    contactList().deleteNILByUIN(uin);
  else
    contactList().deleteByUIN(uin);
  updateVisibleList();
}

void MainWindow::setOnlineStatus(icqStatus kst, unsigned long lst)
{
  if(logged==TRUE)
  {
    statebutton->setStatus(kst);
    icq_ChangeStatus(&icqlink, lst);
    cur_status = kst;
  }
  else
  {
    statebutton->setStatus(stLogin);
    if(useproxy)
      icq_SetProxy(&icqlink, proxyhost, proxyport, proxyauth, proxyuser, proxypass);
    else
      icq_UnsetProxy(&icqlink);
    if(icq_Connect(&icqlink, server, port) != -1)
    {
      login(lst);
      log_status = kst;
    }
    else
      statebutton->setStatus(stOffline);
  }
}

void MainWindow::setStatus(int status)
{
  switch(status)
  {
    case stOffline:
      if(logged)
      {
        logged = FALSE;
        icq_Logout(&icqlink);
      }
      statebutton->setStatus(stOffline);
      cur_status = stOffline;
      contactList().setAllOffline();
      disconnect();
      break;
    case stOnline:
      setOnlineStatus(stOnline, STATUS_ONLINE);
      break;
    case stAway:
      setOnlineStatus(stAway, STATUS_AWAY);
      break;
    case stDND:
      setOnlineStatus(stDND, STATUS_DND);
      break;
    case stNA:
      setOnlineStatus(stNA, STATUS_NA);
      break;
    case stOccupied:
      setOnlineStatus(stOccupied, STATUS_OCCUPIED);
      break;
    case stInvisible:
      setOnlineStatus(stInvisible, STATUS_INVISIBLE);
      break;
    case stFFC:
      setOnlineStatus(stFFC, STATUS_FREE_CHAT);
      break;
    default:
      statebutton->setStatus((icqStatus)status);
      cur_status = (icqStatus)status;
      break;
  }
  setToolTip();
}

void MainWindow::setLogStatus()
{
  setStatus(log_status);
}

icqStatus MainWindow::status()
{
  return cur_status;
}

void MainWindow::login(unsigned long status)
{
  icqSocket = icq_GetSok(&icqlink);
  icqProxySocket = icq_GetProxySok(&icqlink);
  if(socketnotifier)
  {
    delete socketnotifier;
    socketnotifier = 0L;
  }
  if(proxynotifier)
  {
    delete proxynotifier;
    proxynotifier = 0L;
  }
  socketnotifier = new QSocketNotifier(icqSocket, QSocketNotifier::Read);
  connect(socketnotifier, SIGNAL(activated(int)), SLOT(dataReceived(int)));
  if(useproxy)
  {
    proxynotifier = new QSocketNotifier(icqProxySocket, QSocketNotifier::Read);
    connect(proxynotifier, SIGNAL(activated(int)), SLOT(dataReceived(int)));
  }
  icq_Login(&icqlink, status);
  if(keepalivetimer == -1)
    keepalivetimer = startTimer(120000);
  if(tcptimer == -1)
    tcptimer = startTimer(100);
  if(autoawaytimer == -1)
    autoawaytimer = startTimer(5000);
  autoawayset = false;
  initTimeOut(autoawaytimeout * 60); // set auto-away timeout
}

void MainWindow::disconnect()
{
  autoawayset = false;
  freeTimeOut(); // clear auto-away timeout
  stopAll();
  icq_Disconnect(&icqlink);
  if(socketnotifier)
  {
    delete socketnotifier;
    socketnotifier = 0L;
  }
  if(proxynotifier)
  {
    delete proxynotifier;
    proxynotifier = 0L;
  }
  killTimer(keepalivetimer);
  keepalivetimer = -1;
  killTimer(tcptimer);
  tcptimer = -1;
  killTimer(autoawaytimer);
  autoawaytimer = -1;
}

void MainWindow::dataReceived(int sok)
{
  if(sok==icqSocket)
    icq_HandleServerResponse(&icqlink);
  if(useproxy)
    if(sok==icqProxySocket)
      icq_HandleProxyResponse(&icqlink);
}

void MainWindow::setupGUICallbacks()
{
  icqlink.icq_Logged = loggedIn;
  icqlink.icq_Disconnected = disconnected;
  icqlink.icq_UserOnline = userOnline;
  icqlink.icq_UserOffline = userOffline;
  icqlink.icq_UserStatusUpdate = userStatusUpdate;
  icqlink.icq_RecvMessage = message;
  icqlink.icq_RecvURL = url;
  icqlink.icq_RecvWebPager = webPager;
  icqlink.icq_RecvMailExpress = mailExpress;
  icqlink.icq_InfoReply = infoReply;
  icqlink.icq_ExtInfoReply = infoExtReply;
  icqlink.icq_Log = logEvent;
  icqlink.icq_RecvAuthReq = authreq;
  icqlink.icq_RecvChatReq = chatReq;
  icqlink.icq_RecvFileReq = fileReq;
  icqlink.icq_RequestNotify = requestNotify;
  icqlink.icq_RecvAdded = added;
  icqlink.icq_SetTimeout = setTimeout;
}

void MainWindow::setTimeout(ICQLINK *link, long interval)
{
  if(!MW->libTimer)
    return;
  if(interval < 0)
  {
    if(MW->libTimer->isActive())
      MW->libTimer->stop();
  }
  else
    MW->libTimer->start(interval * 1000, TRUE);
}

void MainWindow::logEvent(ICQLINK *link, time_t time, unsigned char level, const char *str)
{
  char lvl[4][4] = {"fat", "err", "wrn", "msg"};
  int std = FALSE;
  FILE *log;
  struct tm *log_time;
  log = fopen(MW->logFile(), "a");
  if(!log)
  {
    log = fdopen(1, "w");
    std = TRUE;
  }
  log_time = localtime(&time);
  fprintf(log, "%02i/%02i/%04i %02i:%02i:%02i [%s] %s", log_time->tm_mday, log_time->tm_mon+1,
          log_time->tm_year+1900, log_time->tm_hour, log_time->tm_min, log_time->tm_sec,
          lvl[level-1], str);
  if(!std)
    fclose(log);
}

void MainWindow::loggedIn(ICQLINK *link)
{
  MW->logged = TRUE;
  MW->setLogStatus();
}

void MainWindow::disconnected(ICQLINK *link)
{
  icqStatus status = MW->status();
  MW->logged = FALSE;
  MW->disconnect();
  MW->setStatus(stOffline);
  if(MW->reconnect)
    MW->setStatus(status);
}

void MainWindow::stopAll()
{
  IcqWindow *ptr;
  findwin->stopCommand();
  for(ptr = icqWinList.first(); ptr != 0L; ptr = icqWinList.next())
  {
    if(ptr->inherits("InfoWindow"))
      ((InfoWindow*)ptr)->stopCommand();
    if(ptr->inherits("MsgWindow"))
      ((MsgWindow*)ptr)->stopCommand();
    if(ptr->inherits("URLSndWindow"))
      ((URLSndWindow*)ptr)->stopCommand();
  }
}

void MainWindow::message(ICQLINK *link, unsigned long uin, unsigned char hour, unsigned char minute,
                         unsigned char day, unsigned char month, unsigned short year, const char *data)
{
  MW->sound->soundEvent("Incoming Message");

  TimeStr time(hour,minute,day,month,year);
  MW->contactList().addMsg(uin,time,data);
  MW->updateRecvWindows();
  MW->updateBlinking();   
}

void MainWindow::url(ICQLINK *link, unsigned long uin, unsigned char hour, unsigned char minute,
                     unsigned char day, unsigned char month, unsigned short year, const char *url,
                     const char *desc)
{
  MW->sound->soundEvent("Incoming URL");

  TimeStr time(hour,minute,day,month,year);
  MW->contactList().addURL(uin,time,url,desc);
  MW->updateRecvWindows();
  MW->updateBlinking();
}

void MainWindow::chatReq(ICQLINK *link, unsigned long uin, unsigned char hour, unsigned char minute,
                         unsigned char day, unsigned char month, unsigned short year, const char *desc,
                         unsigned long seq)
{
  MW->sound->soundEvent("Chat Request");

  TimeStr time(hour,minute,day,month,year);
  MW->contactList().addChatReq(uin,time,desc,seq);
  MW->updateRecvWindows();
  MW->updateBlinking();
}

void MainWindow::webPager(ICQLINK *link, unsigned char hour, unsigned char minute,
                          unsigned char day, unsigned char month, unsigned short year,
                          const char *nick, const char *email, const char *msg)
{
  MW->sound->soundEvent("System Message");

  TimeStr time(hour, minute, day, month, year);
  MW->contactList().addPager(0, time, nick, email, msg);
  MW->updateRecvWindows();
  MW->updateBlinking();
}

void MainWindow::mailExpress(ICQLINK *link, unsigned char hour, unsigned char minute,
                             unsigned char day, unsigned char month, unsigned short year,
                             const char *nick, const char *email, const char *msg)
{
  MW->sound->soundEvent("System Message");

  TimeStr time(hour, minute, day, month, year);
  MW->contactList().addExpress(0, time, nick, email, msg);
  MW->updateRecvWindows();
  MW->updateBlinking();
}

void MainWindow::fileReq(ICQLINK *link, unsigned long uin, unsigned char hour, unsigned char minute,
                         unsigned char day, unsigned char month, unsigned short year, const char *desc,
                         const char *file, unsigned long size, unsigned long seq)
{
  MW->sound->soundEvent("File Request");

  TimeStr time(hour,minute,day,month,year);
  MW->contactList().addFileReq(uin,time,desc, file, size, seq);
  MW->updateRecvWindows();
  MW->updateBlinking();
}


void MainWindow::authreq(ICQLINK *link, unsigned long uin, unsigned char hour, unsigned char minute,
                         unsigned char day, unsigned char month, unsigned short year, const char *nick,
                         const char *first, const char *last, const char *email, const char *reason)
{
  MW->sound->soundEvent("Authorization Message");

  TimeStr time(hour,minute,day,month,year);
  MW->contactList().addAuth(uin,time,nick,first,last,email,reason);
  MW->updateRecvWindows();
  MW->updateBlinking();
}

void MainWindow::added(ICQLINK *link, unsigned long uin, unsigned char hour, unsigned char minute,
                       unsigned char day, unsigned char month, unsigned short year, const char *nick,
                       const char *first, const char *last, const char *email)
{
  MW->sound->soundEvent("System Message");

  TimeStr time(hour,minute,day,month,year);
  MW->contactList().addAdded(uin,time,nick,first,last,email);
  MW->updateRecvWindows();
  MW->updateBlinking();
}

void MainWindow::infoReply(ICQLINK *link, unsigned long uin, const char *nick, const char *first,
                           const char *last, const char *email, char auth)
{
  MW->infoReplyHandler(uin, nick, first, last, email, auth);
}

void MainWindow::infoExtReply(ICQLINK *link, unsigned long uin, const char *city,
                              unsigned short country_code, char country_stat, const char *state,
                              unsigned short age, char gender, const char *phone, const char *hp,
                              const char *about)
{
  MW->infoExtReplyHandler(uin, city, country_code, country_stat,
                          state, age, gender, phone, hp, about);
}

void MainWindow::infoReplyHandler(unsigned long uin, const char *nick, const char *first,
                                  const char *last, const char *email, char auth)
{
  IcqWindow *ptr;
  
  /* It is probably infoReply for request from InfoWindow */
  for(ptr = icqWinList.first(); ptr != 0L; ptr = icqWinList.next())
  {
    if(ptr->inherits("InfoWindow"))
    {
      InfoWindow *iptr=(InfoWindow*)ptr;
      if(iptr->getUIN() == uin)
        iptr->updateInfo(nick, first, last, email, auth);
    }
  }

/* Or maybe it is infoReply for request from UserList about some NotInList user */
  MW->contactList().updateInfoByUIN(uin, nick, first, last, email, auth);
}

void MainWindow::infoExtReplyHandler(unsigned long uin, const char *city, unsigned short country_code,
                                     char country_stat, const char *state, unsigned short age,
                                     char gender, const char *phone, const char *hp, const char *about)
{
  IcqWindow *ptr;
  for(ptr = icqWinList.first(); ptr != 0L; ptr = icqWinList.next())
  {
    if(ptr->inherits("InfoWindow"))
    {
      InfoWindow *iptr=(InfoWindow*)ptr;
      if(iptr->getUIN() == uin)
        iptr->updateExtInfo(city, country_code, country_stat, state, age,
                            gender, phone, hp, about);
    }
  }
}

void MainWindow::requestNotify(ICQLINK *link, unsigned long id, int type, unsigned int length, void *data)
{
  MW->doNotify(id,type,length,data);
}

void MainWindow::doNotify(unsigned long id, int type, unsigned int length, void *data)
{
  IcqWindow *ptr;

  for(ptr = icqWinList.first(); ptr != 0L; ptr = icqWinList.next())
    if(ptr->seq() == id)
      ptr->requestNotify(type, length, data);
}

void MainWindow::timerEvent(QTimerEvent *te)
{
  if(te->timerId() == keepalivetimer)
    icq_KeepAlive(&icqlink);
  if(te->timerId() == tcptimer)
    icq_TCPMain(&icqlink);
  if(te->timerId() == autoawaytimer)
    autoAway();
}

void MainWindow::updateVisibleList()
{
  if(listwidget)
    listwidget->changeList();
}

void MainWindow::addAlertWin(unsigned long uin)
{
  AlertMsgBox *win = 0L, *ptr;
  QString text;

  for(ptr = alertWinList.first(); ptr != 0L; ptr = alertWinList.next())
  {
    if(ptr->inherits("AlertMsgBox"))
    {
      AlertMsgBox *box=(AlertMsgBox*)ptr;
      if(box->uin() == uin)
      {
        box->raise();
        return;
      }
    }
  }

  time_t tmsec = time(0L);
  struct tm *tmstr = localtime(&tmsec);
  text.sprintf(i18n("User %s is online\n%02i:%02i:%02i %02i/%02i/%04i"),
               (const char*)contactList().getNameByUIN(uin), tmstr->tm_hour, tmstr->tm_min,
               tmstr->tm_sec, tmstr->tm_mon+1, tmstr->tm_mday, tmstr->tm_year+1900);
  win = new AlertMsgBox(uin, i18n("Online Alert"), text);
  alertWinList.append(win);
  win->show();

  MW->sound->soundEvent("Online Alert");
}

void MainWindow::delAlertWin(AlertMsgBox *win)
{
  alertWinList.removeRef(win);
}

void MainWindow::updateRecvWindows()
{
  IcqWindow *ptr;
  for(ptr = icqWinList.first(); ptr != 0L; ptr = icqWinList.next())
  {
    if(ptr->inherits("RecvWindow"))
    {
      RecvWindow *box=(RecvWindow*)ptr;
      box->updateNextAvailability();
    }
  }
}

void MainWindow::setIcon(QPixmap icon)
{
  stateIcon = icon;
  if(!blinkFlag)
  {
    KWM::setMiniIcon(winId(), stateIcon);
    dockwidget->setIcon(stateIcon);
  }
}

void MainWindow::setBlinking(int flag)
{
  blinkFlag = flag;
  if(blinkFlag)
    togglePixmap(0);
  else
    setIcon(stateIcon);
}

void MainWindow::togglePixmap(int num)
{
  KWM::setMiniIcon(winId(), blinkPixmap[num]);
  dockwidget->setIcon(blinkPixmap[num]);
  if(num == 0)
    setKeyboardLED(TRUE);
  else
    setKeyboardLED(FALSE);
}

int MainWindow::isUnreadMsgs()
{
  return (getFirstUnreadMsgUIN() != 0);
}

unsigned long MainWindow::getFirstUnreadMsgUIN()
{
  for(unsigned int i=0; i<listwidget->count(); i++)
  {
    UserItem *ptr = listwidget->getItem(i);
    if(ptr->canBeSelected())
      if(contactList().getNumUnreadMsgsByUIN(ptr->getUIN()))
        return ptr->getUIN();
  }
  return 0;
}

void MainWindow::updateHistoryWindows(unsigned long uin)
{
  IcqWindow *ptr;
  for(ptr=icqWinList.first(); ptr!=0L; ptr=icqWinList.next())
  {
    if(ptr->inherits("HistoryWindow"))
    {
      HistoryWindow *win=(HistoryWindow*)ptr;
      if(win->UIN() == uin)
        win->refresh();
    }
  }
}

void MainWindow::setBlinkPixmap(const char *p)
{
  KIconLoader *il = kapp->getIconLoader();
  blinkPixmap[0] = il->loadIcon(p) ;
}

void MainWindow::setToolTip()
{
  QString text;
  if(isUnreadMsgs())
  {
    unsigned long u = getFirstUnreadMsgUIN();
    if(u)
    {
      switch(contactList().getFirstUnreadMsgTypeByUIN(u))
      {
        case MSG_SENT:
        case MSG_RECV:
          text = i18n("Message from ");
          break;
        case MSG_URL_SENT:
        case MSG_URL_RECV:
          text = i18n("URL from ");
          break;
        case MSG_AUTH_RECV:
          text = i18n("Authorization request from ");
          break ;
        default:
          text = i18n("Event from ");
          break;
      }
      text += contactList().getNameByUIN(u);
    }
  }
  else
  {
    switch(cur_status)
    {
      case stLogin:
        text = i18n("Connecting");
        break;
      case stOffline:
        text = i18n("Offline");
        break;
      case stOnline:
        text = i18n("Online");
        break;
      case stAway:
        text = i18n("Away");
        break;
      case stNA:
        text = i18n("Not Available");
        break;
      case stDND:
        text = i18n("Do not Disturb");
        break;
      case stOccupied:
        text = i18n("Occupied");
        break;
      case stInvisible:
        text = i18n("Invisible");
        break;
      case stFFC:
        text = i18n("Free for Chat");
        break;
    }
  }
  dockwidget->setToolTip(text);
}

void MainWindow::updateBlinking()
{
  if(isUnreadMsgs())
  {
    unsigned long u = getFirstUnreadMsgUIN();
    if(u)
      switch(contactList().getFirstUnreadMsgTypeByUIN(u))
      {
        case MSG_SENT:
        case MSG_RECV:
          setBlinkPixmap("message.xpm");
          break;
        case MSG_URL_SENT:
        case MSG_URL_RECV:
          setBlinkPixmap("url.xpm");
          break;
        case MSG_AUTH_RECV:
          setBlinkPixmap("auth.xpm") ;
          break ;
        case MSG_CHAT_REQ_RECV:
          setBlinkPixmap("chat.xpm");
          break;
        case MSG_FILE_REQ_RECV:
          setBlinkPixmap("file.xpm");
          break;
        case MSG_ADDED:
          setBlinkPixmap("exclam.xpm");
          break;
        default:
          setBlinkPixmap("null.xpm");
          break;
      }
  }
  setToolTip();
  int a = listwidget->blinkItemsCount();
  if(a)
    setBlinking(TRUE);
  else
    setBlinking(FALSE);
}

void MainWindow::addIcqWindow(IcqWindow *win)
{
  icqWinList.append(win);
}

void MainWindow::delIcqWindow(IcqWindow *win)
{
  icqWinList.removeRef(win);
  delete win;
}

// FIXME: The following code is coming soon !
void MainWindow::setKeyboardLED(bool on)
{
}

QStrList MainWindow::getConfigDirList()
{
  QDir dir(appdir+"/owners");
  return *dir.entryList("*.conf", QDir::Files | QDir::Readable);
}

void MainWindow::fillOwnersPopup()
{
  QStrList uinlist = getConfigDirList();
  QString ownstr;
  ownstr.setNum(getOwnerConfigUIN());
  ownersmenu->clear();
  ownersmenu->setCheckable(TRUE);
  ownersmenu->setMouseTracking(TRUE);
  connect(ownersmenu, SIGNAL(activated(int)), SLOT(changeOwner(int)));
  for(unsigned int i = 0; i < uinlist.count(); i++)
  {
    QString uinstr = uinlist.at(i);
    uinstr.resize(uinstr.find(".")+1);
    ownersmenu->insertItem(uinstr);
    ownersmenu->setItemChecked(ownersmenu->idAt(i), uinstr==ownstr);
  }
}

void MainWindow::changeOwner(int id)
{
  unsigned long newUIN = QString(ownersmenu->text(id)).toULong();
  if(newUIN == uin)
    return;
  findwin->clearCommand();
  saveSessionConfig();
  setStatus(stOffline);
  icq_Done(&icqlink);
  prepareNewUIN(newUIN);
}
