/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: faildialog.cpp,v 1.1 2000/05/24 16:58:31 denis Exp $
// $Log: faildialog.cpp,v $
// Revision 1.1  2000/05/24 16:58:31  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.4  2000/01/10 16:08:13  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.3  1999/07/16 15:47:53  denis
// Cleaned up.
//

//#include <stdio.h>
#include <kapp.h>

#include "faildialog.h"

#include "faildialog.moc"

FailDialog::FailDialog(QWidget *parent, const char *name, bool modal, WFlags f)
  : QSemiModal(parent, name, modal, f)
{
  label = new QLabel(i18n("Can't establish DIRECT connection to user"), this);

  button1 = new QPushButton(i18n("Send Through\nServer"), this);
  button2 = new QPushButton(i18n("Try Again"), this, SLOT(buttonClicked()));
  button3 = new QPushButton(i18n("Cancel"), this, SLOT(buttonClicked()));

  connect(button1, SIGNAL(clicked()), SLOT(buttonClicked()));
  connect(button2, SIGNAL(clicked()), SLOT(buttonClicked()));
  connect(button3, SIGNAL(clicked()), SLOT(buttonClicked()));

  setGeometry(100, 100, sizeHint().width(), sizeHint().height());

  layout();
}

void FailDialog::setLabelText(const QString &text)
{
  if (label)
    label->setText(text);
}

QSize FailDialog::sizeHint() const
{
  int mlr=10;
  int mtb=10;
//  int sp=20;

  QSize ls=label->sizeHint();
  QSize bs=QSize(150,100);
  //QMAX(QMAX(button1->sizeHint(), button2->sizeHint()), button3->sizeHint());

  return QSize( QMAX(bs.width(), ls.width())+mlr*2, ls.height()+bs.height()+mtb*2);
}

void FailDialog::resizeEvent(QResizeEvent *)
{
  layout();
}

void FailDialog::closeEvent(QCloseEvent *e)
{
  QSemiModal::closeEvent(e);
}

void FailDialog::layout()
{
  int mlr=10;
  int mtb=10;
  int vs=20;
  int bhs=10;

  QSize frame(width()-mlr*2, height()-mtb*2);

  int bwidth=(width()-mlr*2-bhs*2)/3;
  int bheight=(height()-mtb*2-vs)/3;

  label->setGeometry(mlr, mtb, frame.width(), frame.height()-bheight-vs);

  int by=mtb+label->height()+vs;
  button1->setGeometry(mlr, by, bwidth, bheight);
  button2->setGeometry(mlr+bwidth+bhs, by, bwidth, bheight);
  button3->setGeometry(mlr+(2*(bwidth+bhs)), by, bwidth, bheight);
}

void FailDialog::buttonClicked()
{
  const QObject *p=sender();

  if (p==button1)
    emit done(1);
  else if (p==button2)
    emit done(2);
  else if (p==button3)
    emit done(3);
}
