/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _FWDLIST_H
#define _FWDLIST_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qlist.h>
#include <qlistbox.h>

#include "useritem.h"

class FwdList : public QListBox {
  Q_OBJECT
public:

  FwdList(QWidget *parent=0, const char *name=0,unsigned long uin=0);
  ~FwdList();
  
  void changeList();
  void paintCell(QPainter *,int,int);
  QList<UserItem> *getSelectedListPtr();  
protected:
  unsigned long defUIN;
  void mousePressEvent(QMouseEvent *);
  QList<UserItem> selectedList;

protected slots:
  void toggle(int);
  
};

class FwdItem : public QListBoxItem {
  
public:
  FwdItem(FwdList *p = 0, unsigned long u=0, bool on=0, const char *t=0);
  unsigned long UIN() { return uin; };
  int height(const QListBox *lb) const;
  int width(const QListBox *lb) const;
  bool isOn() { return selected; };
  void setOn(bool s) { selected = s; };
  bool isOnline() { return online; };
  void paint(QPainter *);

protected:
  FwdList *parent;
  QString nick;
  unsigned long uin;
  bool online;
  bool selected;

};

#endif
