/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: msgwindow.cpp,v 1.5 2000/07/28 18:36:27 denis Exp $
// $Log: msgwindow.cpp,v $
// Revision 1.5  2000/07/28 18:36:27  denis
// Code for setting per-user "Send Thru Server" status added.
//
// Revision 1.4  2000/07/23 16:31:19  denis
// Alt+S accelerator along with Ctrl+Enter for "send" action was added.
//
// Revision 1.3  2000/07/09 18:42:39  denis
// Attempt to add Alt+S accelerator.
//
// Revision 1.2  2000/06/17 17:10:11  denis
// Cleanups.
//
// Revision 1.1  2000/05/24 16:58:31  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.33  2000/05/11 11:56:55  denis
// Timeout on send message was commented out. Theoretically, it isn't
// needed anymore after outgoing packet queue was implemented.
// Some cleanups.
//
// Revision 1.32  2000/01/10 16:08:47  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.31  1999/12/28 15:57:13  denis
// ICQ_NOTIFY_ACK changed to ICQ_NOTIFY_FAILED in responseTimeOut()
//
// Revision 1.30  1999/12/28 01:50:01  bills
// fixed sendMessage call back to ICQ_SEND_BESTWAY
//
// Revision 1.29  1999/12/02 14:35:07  denis
// Random IcqWindow segfaults fixed.
// Cleanups.
//
// Revision 1.28  1999/11/02 02:08:59  kyle
// msgwindow.cpp - fixed crash in MsgWindow::closeEvent
//
// Revision 1.27  1999/10/15 15:03:19  kyle
// msgwindow.cpp - enabled timeout, now assumes message was recieved after 15 seconds
//
// Revision 1.26  1999/10/14 13:00:34  denis
// Cleanups.
//
// Revision 1.25  1999/10/08 10:38:48  guruz
// Removed some crap i made
//
// Revision 1.24  1999/10/05 19:00:36  guruz
// -Added Message Timeout Patch by kyle@13th-floor.org
// -Fixed bug in wrapedit.cpp
//
// Revision 1.23  1999/09/29 17:33:29  denis
// Cleanups.
//
// Revision 1.22  1999/07/16 15:48:24  denis
// Cleaned up.
//
// Revision 1.21  1999/07/16 13:04:18  denis
// Internalization support added.
// Smart loading of spinning face animation implemented.
//
// Revision 1.20  1999/07/12 15:23:28  cproch
// - changed icq_* function calls and callback function to support
//   icqlib with ICQLINK identifier.
// - look for FIXME in mainwindow.cpp
//
// Revision 1.19  1999/07/03 20:44:34  peters
// New File to expand the preferences in KICQ.  Not yet working.
//
// Revision 1.18  1999/07/03 02:43:51  bills
// uses ICQ_SEND_* constants for SendMessage instead of tcp_flag hack
//
// Revision 1.16  1999/04/17 20:22:19  bills
// modified for new icqwindow base class
//
// Revision 1.15  1999/03/31 01:22:46  bills
// modified sendMessage to check tcpflag and send message appropriately
//
// Revision 1.14  1999/03/28 23:24:27  whale
//
//
// Added displaying of multiple recepient list
//
// Revision 1.13  1999/03/28 02:00:48  bills
// fixed number of args to icq_SendMessage
//
// Revision 1.12  1999/03/16 01:09:21  tim
// Cleanup authorize code.
//
// Revision 1.11  1998/12/08 16:24:58  denis
// Cleaned up a little before releasing
//
// Revision 1.10  1998/11/23 10:07:51  denis
// WrapEdit workaround
//

#include <qmsgbox.h>
#include <qmovie.h>
#include <qregexp.h>
#include <qkeycode.h>
#include <qaccel.h>
#include <kapp.h>
#include <kiconloader.h>
#include <keditcl.h>

#include "msgwindow.h"
#include "mainwindow.h"
#include "fwdlist.h"
#include "wrapedit.h"
#include "fwdlist.h"
#include "faildialog.h"
#include "userlist.h"

#include "msgwindow.moc"

MsgWindow::MsgWindow(const char *n, unsigned long u, const char *em, const char *msg) : IcqWindow()
{
  QString text;
  QPixmap infopix;
  KIconLoader *il = kapp->getIconLoader();
  setCaption(i18n("Send Message"));
  tobox = new QGroupBox(i18n("To"),this);
  sendbutton = new QPushButton(i18n("&Send"),this);
  QAccel *a = new QAccel(this);
  a->connectItem(a->insertItem(Key_Return+CTRL), this, SLOT(sendMessage()));
  connect(sendbutton, SIGNAL(clicked()),SLOT(sendMessage()));
  morebutton =  new QPushButton(i18n("More"),this);
  morebutton->setToggleButton(TRUE);
  connect(morebutton,SIGNAL(clicked()),SLOT(moreOptions()));
  multibutton = new QPushButton(i18n("Multiple &Recepients >>"),this);
  multibutton->hide();
  multibutton->setToggleButton(TRUE);
  connect(multibutton,SIGNAL(clicked()),SLOT(multiRecpts()));
  multibox = new QGroupBox(i18n("Select Recepients"),this);
  multibox->hide();
  multilist = new FwdList(this,"",u);
  multilist->hide();
  cancelbutton = new QPushButton(i18n("&Cancel"),this);
  connect(cancelbutton, SIGNAL(clicked()),SLOT(cancelMessage()));
  uinline = new QLineEdit(this);
  uinline->setFocusPolicy(QWidget::NoFocus);
  uinlabel = new QLabel(uinline,i18n("ICQ#:"),this);
  handleline = new QLineEdit(this);
  handleline->setFocusPolicy(QWidget::NoFocus);
  handlelabel = new QLabel(handleline,i18n("Handle:"),this);
  emailline = new QLineEdit(this);
  emailline->setFocusPolicy(QWidget::NoFocus);
  emaillabel = new QLabel(emailline,i18n("EMail:"),this);
  infobutton = new QPushButton(this);
  infopix = il->loadIcon("info.xpm");
  infobutton->setPixmap(infopix);
  infobutton->resize(infopix.width()+6, infopix.height()+6);
  connect(infobutton, SIGNAL(clicked()), SLOT(infoRequest()));
  editbox = new WrapEdit(this);
  editbox->setWraping(TRUE);
  editbox->setLimit(450);
  editlabel = new QLabel(editbox,i18n("Enter Message:"),this);
  updateanim = new QLabel(this);
  QString filename = kapp->localkdedir()+"/share/apps/"+kapp->appName()+"/pics/search.gif";
  QFile testfile(filename);
  if(!testfile.exists())
    filename = kapp->kde_datadir()+"/"+kapp->appName()+"/pics/search.gif";
  updateanim->setMovie(QMovie((const char*)filename));
  updateanim->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
  updateanim->setAlignment(AlignCenter);
  updateanim->movie()->pause();
  setName(n);
  setUIN(u);
  setEMail(em);
  if(msg)
  {
    text = msg;
    if(MW->isQuote())
    {
      text.replace(QRegExp("\n"), "\n> ");
      text = "> "+text;
      editbox->setText(text);
    }
    setMessage(text);
  }
  editbox->setFocus();
  resize(500,250);
  setMinimumSize(400,250);
  faildialog=0L;
}

MsgWindow::~MsgWindow()
{
  if(sendbutton)
    delete sendbutton;
  if(cancelbutton)
    delete cancelbutton;
  if(tobox)
    delete tobox;
  if(uinlabel)
    delete uinlabel;
  if(handlelabel)
    delete handlelabel;
  if(emaillabel)
    delete emaillabel;
  if(uinline)
    delete uinline;
  if(handleline)
    delete handleline;
  if(emailline)
    delete emailline;
  if(infobutton)
    delete infobutton;
  if(editbox)
    delete editbox;
  if(editlabel)
    delete editlabel;
  if(updateanim)
    delete updateanim;
  if(morebutton)
    delete morebutton;
  if(multibutton)
    delete multibutton;
  if(multilist)
    delete multilist;
  if(multibox)
    delete multibox;
  if(faildialog)
    delete faildialog;
}

void MsgWindow::requestNotify(int type, int length, void *data)
{
  if(type==ICQ_NOTIFY_ACK)
    saveHistory();

  if(type==ICQ_NOTIFY_FAILED)
  {
    stopCommand();
    if(!faildialog)
    {
      faildialog=new FailDialog(this, "fail dialog", TRUE);
      faildialog->move(x()+50, y()+50);
      faildialog->resize(width()-100, height()-100);
      connect(faildialog, SIGNAL(done(int)), this, SLOT(failResult(int)));
    }
    faildialog->show();
  }

  IcqWindow::requestNotify(type, length, data);
}

void MsgWindow::resizeEvent(QResizeEvent *re)
{
  IcqWindow::resizeEvent(re);
  int morew = 0;
  if(multibutton->isOn())
  {
    QSize mbx = multibox->sizeHint();
    morew = QMAX(multilist->width(),mbx.width()) + 16;
  }

  QSize uinlblsize,handlelblsize,emaillblsize,toboxsize,editlblsize,btn1size,btn2size;
  toboxsize.setWidth(width()-6-morew);
  uinlblsize = uinlabel->sizeHint();
  handlelblsize = handlelabel->sizeHint();
  emaillblsize = emaillabel->sizeHint();
  int w = (toboxsize.width()-uinlblsize.width()-handlelblsize.width()-emaillblsize.width()-75)/4;
  uinline->resize(w,uinline->sizeHint().height());
  handleline->resize(w,uinline->sizeHint().height());
  emailline->resize(w*2-7,uinline->sizeHint().height());
  uinlabel->resize(uinlblsize.width(),uinline->height());
  handlelabel->resize(handlelblsize.width(),handleline->height());
  emaillabel->resize(emaillblsize.width(),emailline->height());
  uinlabel->move(12,15);
  uinline->move(3+uinlabel->x()+uinlabel->width(),15);
  handlelabel->move(12+uinline->x()+uinline->width(),15);
  handleline->move(3+handlelabel->x()+handlelabel->width(),15);
  emaillabel->move(12+handleline->x()+handleline->width(),15);
  emailline->move(3+emaillabel->x()+emaillabel->width(),15);
  tobox->setGeometry(3,3,toboxsize.width(),uinline->height()+19);
  infobutton->move(10+emailline->x()+emailline->width(),15+(uinline->height()-infobutton->height())/2);
  btn1size = sendbutton->sizeHint();
  btn2size = cancelbutton->sizeHint();
  int h = QMAX(btn1size.height(),btn2size.height());
  w = QMAX(QMAX(btn1size.width(),btn2size.width()),75);
  QSize mb = multibutton->sizeHint();
  multibutton->setGeometry(width() - mb.width() - 10 - morew, height() - h - 12,
    mb.width(),mb.height());

  int moreh = 0;
  if(morebutton->isOn())
  {
    moreh = multibutton->height() * 2;
  }

  sendbutton->setGeometry(width()/2-w-6-morew/2,height()-h-12-moreh,w,h);
  cancelbutton->setGeometry(width()/2+6-morew/2,height()-h-12-moreh,w,h);
  morebutton->setGeometry(10,height()-h-12-moreh,w,h);
  editlblsize = editlabel->sizeHint();
  editlabel->setGeometry(6,8+tobox->height(),editlblsize.width(),editlblsize.height());
  editbox->setGeometry(3,editlabel->y()+editlabel->height()+4,width()-6-morew,
                       height()-editlabel->y()-editlabel->height()-h-28-moreh);
  updateanim->setGeometry(width()-40-morew,height()-40-moreh,32,32);
  updateanim->movie()->restart();
  QSize ml = multilist->sizeHint();
  multibox->setGeometry(width() - ml.width() - 12,3,
    ml.width() + 4, height()-moreh);
  multilist->setGeometry(width() - ml.width() - 10,15,
    ml.width(),height()-moreh-14);
}

void MsgWindow::setUIN(unsigned long u)
{
  uin = u;
  QString text;
  text.setNum(uin);
  uinline->setText(text);
}

void MsgWindow::setName(const char *name)
{
  handleline->setText(name);
}

void MsgWindow::setEMail(const char *email)
{
  emailline->setText(email);
}

void MsgWindow::setMessage(const char *msg)
{
  message = msg;
}

void MsgWindow::sendMessage()
{
  sendMessage(MW->contactList().getThruServerByUIN(uin)?ICQ_SEND_THRUSERVER:ICQ_SEND_BESTWAY);
}

void MsgWindow::sendMessage(int method)
{
  QString tmp;
  if(MW->isLogged())
  {
    tmp = editbox->text();
    if(MW->isConvertCRLF())
      tmp.replace(QRegExp("\n"),"\r\n");
    sequence = icq_SendMessage(&MW->icqlink, uin,(const char*)tmp, method);
    updateanim->movie()->unpause();
    sendbutton->setEnabled(FALSE);
  }
  else
    QMessageBox::warning(this, i18n("Error"), i18n("You are not connected to the icq network!"));
}

void MsgWindow::cancelMessage()
{
  if(sequence==0)
    close();
  else
    stopCommand();
}

void MsgWindow::infoRequest()
{
  MW->infoWindow(uin);
}

void MsgWindow::stopCommand()
{
  updateanim->movie()->pause();
  sendbutton->setEnabled(TRUE);
  sequence = 0;
}

void MsgWindow::saveHistory()
{
  time_t curtm = time(0L);
  struct tm *t = localtime(&curtm);
  TimeStr time(t->tm_hour,t->tm_min,t->tm_mday,t->tm_mon+1,t->tm_year+1900);

  icqMessage msg(uin,time,editbox->text(),MSG_SENT);
  QString historypath = MW->contactsDir();
  msg.save(historypath);
  MW->updateHistoryWindows(msg.uin());
}

void MsgWindow::moreOptions()
{
  int mwHeight = height();
  QSize multiSize = multibutton->sizeHint();

  if(morebutton->isOn())
  {
    mwHeight += multiSize.height() * 2;
    multibutton->show();
  }
  else
  {   
    mwHeight -= multiSize.height() * 2;
    multibutton->hide();
  }
   
  resize(width(),mwHeight);
}

void MsgWindow::multiRecpts()
{
  int mwWidth = width();
  QSize listSize = multilist->sizeHint();
  QSize boxSize = multibox->sizeHint();

  if(multibutton->isOn())
  {
    mwWidth += QMAX(listSize.width(),boxSize.width()) + 16;
    multilist->show();
    multibox->show();
  }
  else
  {
    mwWidth -= QMAX(listSize.width(),boxSize.width()) + 16;
    multilist->hide();
    multibox->hide();
  }

  resize(mwWidth,height());
}

void MsgWindow::failResult(int i)
{
  faildialog->close();
  faildialog=0L;

  if(i==3)
    cancelMessage();
  if(i==2)
    sendMessage();
  if(i==1)
  {
    MW->contactList().setThruServerByUIN(uin, TRUE);
    sendMessage(ICQ_SEND_THRUSERVER);
  }
}
