/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _RECVWINDOW_
#define _RECVWINDOW_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <time.h>
#include <qpushbt.h>
#include <qgrpbox.h>
#include <qlabel.h>
#include <qmlined.h>
#include <qlined.h>
#include <qwidgetstack.h>

#include "icqwindow.h"
#include "icqmessage.h"

class KURLLineEdit;

class RecvDetail : public QGroupBox {
  Q_OBJECT
public:
  icqMessage *message;

  RecvDetail(icqMessage *msg, QWidget *parent = 0);
  void activateLayout();
protected slots:
  void addRequest();
  void replyRequest();
protected:
  QVBoxLayout *layout;
  QGroupBox *actionFrame;
  QHBoxLayout *actionLayout;

  void addActionFrame();
  void addActionButton(QString, QString, bool);
};

class RecvMessage : public RecvDetail {
  Q_OBJECT
public:
  RecvMessage(icqMessage *msg, QWidget *parent = 0);
};

class RecvURL : public RecvDetail {
  Q_OBJECT
public:
  RecvURL(icqMessage *msg, QWidget *parent = 0);
};

class RecvAuth : public RecvDetail {
  Q_OBJECT
public:
  RecvAuth(icqMessage *msg, QWidget *parent = 0);
protected slots:
  void authorizeRequest();
  void declineRequest();
};

class RecvChatReq : public RecvDetail {
  Q_OBJECT
public:
  RecvChatReq(icqMessage *msg, QWidget *parent = 0);
protected slots:
  void acceptRequest();
  void declineRequest();
};

class RecvFileReq : public RecvDetail {
  Q_OBJECT
public:
  RecvFileReq(icqMessage *msg, QWidget *parent = 0);
protected slots:
  void saveRequest();
  void saveAsRequest();
  void declineRequest();
};

class RecvAdded : public RecvDetail {
  Q_OBJECT
public:
  RecvAdded(icqMessage *msg, QWidget *parent = 0);
protected slots:
  void sendContactsRequest();
};

class RecvWindow : public IcqWindow {
  Q_OBJECT
public:
  RecvWindow(QList<icqMessage>*, int, unsigned long, bool d = TRUE);
  void setUIN(unsigned long);
  void setName(const char*);
  void setEMail(const char*);
  void setTime(TimeStr);
  unsigned long UIN();
  void updateNextAvailability();
  void makeWindow(icqMessage *msg);
public slots:
  void closeBtn();
signals:
protected:
  QString recvCaption;
  QList<icqMessage> *list;
  int start, idx;
  bool delflag;
  unsigned long msgUin;
  QString nick;
  QString email;
  QLineEdit *uinline, *handleline, *emailline, *dateline, *timeline;
  QPushButton *nextbtn;
  QVBoxLayout *page;
  QWidgetStack *detail;
protected slots:
  void infoRequest();
  void readNext();
private:
private slots:
};
#endif /* _RECVWINDOW_ */
