/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: prefaway.cpp,v 1.1 2000/05/24 16:59:04 denis Exp $
// $Log: prefaway.cpp,v $
// Revision 1.1  2000/05/24 16:59:04  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.3  2000/01/10 16:09:01  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//

// This file does not exist in CVS
// Who says? ;)

#include <qlayout.h>
#include <kapp.h>

#include "prefaway.h"

#include "prefaway.moc"

AwayWidget::AwayWidget(QWidget *parent) : QWidget(parent)
{
  QBoxLayout *topLayout = new QVBoxLayout(this);

  QLabel *mainlabel = new QLabel(i18n("Enter Away Settings:"),this);
  mainlabel->setMinimumSize(mainlabel->sizeHint());
  topLayout->addWidget(mainlabel);

  topLayout->addSpacing(7);

  QGroupBox *awaybox = new QGroupBox(i18n("Auto-Away (minutes)"), this);

  QBoxLayout *boxLayout = new QVBoxLayout(awaybox, 10, 7);

  boxLayout->addSpacing(7);

  enablebox = new QCheckBox(i18n("Enable Auto-Away"), awaybox);
  enablebox->setMinimumSize(enablebox->sizeHint());
  boxLayout->addWidget(enablebox);

  QLabel *awaylabel = new QLabel(i18n("Away:"), awaybox);
  awaylabel->setMinimumSize(awaylabel->sizeHint());
  boxLayout->addWidget(awaylabel);

  awayline = new KIntegerLine(awaybox);
  awayline->setMinimumSize(awayline->sizeHint());
  awayline->setMaximumHeight(awayline->sizeHint().height());
  boxLayout->addWidget(awayline, 1);

  awaytonabox = new QCheckBox(i18n("Change to NA if away is set by user"), awaybox);
  awaytonabox->setMinimumSize(awaytonabox->sizeHint());
  boxLayout->addWidget(awaytonabox);

  QLabel *nalabel = new QLabel(i18n("NA:"), awaybox);
  nalabel->setMinimumSize(nalabel->sizeHint());
  boxLayout->addWidget(nalabel);

  naline = new KIntegerLine(awaybox);
  naline->setMinimumSize(naline->sizeHint());
  naline->setMaximumHeight(naline->sizeHint().height());
  boxLayout->addWidget(naline, 1);

  boxLayout->activate();
  topLayout->addWidget(awaybox);

  topLayout->addStretch(1);

  topLayout->activate();
}

void AwayWidget::setInfo(int away, int na, bool enable, bool awaytona)
{
  awayline->setValue(away);
  naline->setValue(na);
  enablebox->setChecked(enable);
  awaytonabox->setChecked(awaytona);
}

unsigned short AwayWidget::away()
{
  return awayline->value();
}

unsigned short AwayWidget::na()
{
  return naline->value();
}

bool AwayWidget::enable()
{
  return enablebox->isChecked();
}

bool AwayWidget::awaytona()
{
  return awaytonabox->isChecked();
}
