/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: prefbrowser.cpp,v 1.1 2000/05/24 16:59:04 denis Exp $
// $Log: prefbrowser.cpp,v $
// Revision 1.1  2000/05/24 16:59:04  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.6  2000/03/01 20:48:29  guruz
// -Added WGet as browser when recieving URLs
// -Modified server prefs
// -fixed some things with special ops
//
// Revision 1.5  2000/01/10 16:09:03  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//

#include <qlayout.h>
#include <kapp.h>

#include "prefbrowser.h"
#include "kwebbrowser.h"

#include "prefbrowser.moc"

BrowserPrefWidget::BrowserPrefWidget(QWidget *parent) : QWidget(parent)
{
  QBoxLayout *topLayout = new QVBoxLayout(this);

  QLabel *mainlabel = new QLabel(i18n("Enter MIME Binding Settings:"), this);
  mainlabel->setMinimumSize(mainlabel->sizeHint());
  topLayout->addWidget(mainlabel);

  topLayout->addSpacing(7);

  QGroupBox *groupbox = new QGroupBox(i18n("MIME Bindings"), this);

  QBoxLayout *boxLayout = new QVBoxLayout(groupbox, 10, 7);

  boxLayout->addSpacing(7);

  QLabel *captionlabel = new QLabel(i18n("Browser:"), groupbox);
  captionlabel->setMinimumSize(captionlabel->sizeHint());
  boxLayout->addWidget(captionlabel);

  browserbox = new QComboBox(groupbox);
  browserbox->clear();
  browserbox->insertItem("KFM");
  browserbox->insertItem("Copy URL to Clipboard");
  browserbox->insertItem("Netscape Navigator");
  browserbox->insertItem("Netscape Navigator with NSS");
  browserbox->insertItem("LYNX");
  browserbox->insertItem("WGET this URL");
  browserbox->setCurrentItem(KWebBrowser::getBrowser());
  browserbox->setMinimumSize(browserbox->sizeHint());
  boxLayout->addWidget(browserbox);

  boxLayout->activate();
  topLayout->addWidget(groupbox);

  topLayout->addStretch(1);

  topLayout->activate();
}

void BrowserPrefWidget::save()
{
  KWebBrowser::setBrowser(browserbox->currentItem());
}
