/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _PREFERENCES_
#define _PREFERENCES_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qpushbt.h>
#include <qlabel.h>
#include <qwidget.h>
#include <qlistview.h>
#include <qdialog.h>

struct PrefItem
{
  QWidget *widget;
  QListViewItem *name;
  PrefItem(QWidget *w, QListViewItem *n)
    {
      widget = w;
      name = n;
    };
};

class UserWidget;
class ServerWidget;
class ProxyWidget;
class LoggingWidget;
class SoundWidget;
class OtherWidget;
class AwayWidget;
class BrowserPrefWidget;
class QPPrefWidget;

class Preferences : public QDialog {
  Q_OBJECT
public:
  Preferences();
  ~Preferences();
  void setOwner(unsigned long, const char*, const char*);
  unsigned long getOwner();
  void setServer(const char *, int);
  void setProxy(bool, const char*, unsigned short, bool, const char*, const char*);
  void setLogging(int, const char*);
  void setSound(bool, bool clear = FALSE);
  void setOther(bool, bool, bool, bool, bool);
  void setAway(int, int, bool, bool);
  void setDefault();
public slots:
signals:
protected:
  QWidget *curPage;
  QList<PrefItem> pageList;
  QListView *prefList;
  UserWidget *userwidget;
  ServerWidget *serverwidget;
  ProxyWidget *proxywidget;
  LoggingWidget *loggingwidget;
  SoundWidget *soundwidget;
  OtherWidget *otherwidget;
  AwayWidget *awaywidget;
  BrowserPrefWidget *browserwidget;
  QPPrefWidget *qpwidget;
  void setPage(QWidget*);
protected slots:
  void accept();
  void curChanged(QListViewItem*);
private:
private slots:
};
#endif /* _PREFERENCES_ */
