/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: preflog.cpp,v 1.1 2000/05/24 16:59:04 denis Exp $
// $Log: preflog.cpp,v $
// Revision 1.1  2000/05/24 16:59:04  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.8  2000/01/10 16:09:07  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.7  1999/12/02 14:32:36  denis
// Layout management implemented.
// Preferences dialog style switched from "Tabbed" dialog to
// "Netscape Preferences"-like style.
//
// Revision 1.6  1999/09/29 17:34:46  denis
// Cleanups.
//
// Revision 1.5  1999/07/16 15:48:40  denis
// Cleaned up.
//
// Revision 1.4  1999/07/16 13:12:20  denis
// Internalization support added.
//
// Revision 1.3  1998/12/08 16:25:51  denis
// Cleaned up a little before releasing
//

#include <qlayout.h>
#include <kapp.h>

#include "preflog.h"

#include "preflog.moc"

LoggingWidget::LoggingWidget(QWidget *parent) : QWidget(parent)
{
  QBoxLayout *topLayout = new QVBoxLayout(this);

  QLabel *mainlabel = new QLabel(i18n("Enter Logging Settings:"),this);
  mainlabel->setMinimumSize(mainlabel->sizeHint());
  topLayout->addWidget(mainlabel);

  topLayout->addSpacing(7);

  QGroupBox *logbox = new QGroupBox(i18n("Logging"), this);

  QBoxLayout *boxLayout = new QVBoxLayout(logbox, 10, 7);

  boxLayout->addSpacing(7);

  QLabel *levellabel = new QLabel(i18n("Level:"), logbox);
  levellabel->setMinimumSize(levellabel->sizeHint());
  boxLayout->addWidget(levellabel);

  levelbox = new QComboBox(logbox);
  levelbox->clear();
  levelbox->insertItem(i18n("Logging off"));
  levelbox->insertItem(i18n("Fatal messages"));
  levelbox->insertItem(i18n("Error messages"));
  levelbox->insertItem(i18n("Warning messages"));
  levelbox->insertItem(i18n("Other messages"));
  levelbox->setMinimumSize(levelbox->sizeHint());
  boxLayout->addWidget(levelbox);

  QLabel *loglabel = new QLabel(i18n("File:"), logbox);
  loglabel->setMinimumSize(loglabel->sizeHint());
  boxLayout->addWidget(loglabel);

  logline = new QLineEdit(logbox);
  logline->setMinimumSize(logline->sizeHint());
  logline->setMaximumHeight(logline->sizeHint().height());
  boxLayout->addWidget(logline, 1);

  boxLayout->activate();
  topLayout->addWidget(logbox);

  topLayout->addStretch(1);

  topLayout->activate();
}

void LoggingWidget::setInfo(int lvl, const char *logname)
{
  levelbox->setCurrentItem(lvl);
  logline->setText(logname);
}

int LoggingWidget::level()
{
  return levelbox->currentItem();
}

const char *LoggingWidget::logfile()
{
  return logline->text();
}
