/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: prefother.cpp,v 1.1 2000/05/24 16:59:04 denis Exp $
// $Log: prefother.cpp,v $
// Revision 1.1  2000/05/24 16:59:04  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.7  2000/01/10 16:09:08  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.6  1999/12/02 14:32:38  denis
// Layout management implemented.
// Preferences dialog style switched from "Tabbed" dialog to
// "Netscape Preferences"-like style.
//
// Revision 1.5  1999/07/16 15:48:42  denis
// Cleaned up.
//
// Revision 1.4  1999/07/16 13:12:21  denis
// Internalization support added.
//
// Revision 1.3  1998/12/08 16:26:52  denis
// Reconnect on disconnect preference option added
// Cleaned up a little before releasing
//

#include <qlayout.h>
#include <kapp.h>

#include "prefother.h"

#include "prefother.moc"

OtherWidget::OtherWidget(QWidget *parent) : QWidget(parent)
{
  QBoxLayout *topLayout = new QVBoxLayout(this);

  QLabel *mainlabel = new QLabel(i18n("Enter Other Settings:"),this);

  mainlabel->setMinimumSize(mainlabel->sizeHint());
  topLayout->addWidget(mainlabel);

  topLayout->addSpacing(7);

  QGroupBox *otherbox = new QGroupBox(i18n("Other"), this);

  QBoxLayout *boxLayout = new QVBoxLayout(otherbox, 10, 7);

  boxLayout->addSpacing(7);

  recodebox = new QCheckBox(i18n("Cyrillic koi8-r - cp1251 recoding"), otherbox);
  recodebox->setMinimumSize(recodebox->sizeHint());
  boxLayout->addWidget(recodebox);

  closebox = new QCheckBox(i18n("Close Receive window when replying"), otherbox);
  closebox->setMinimumSize(closebox->sizeHint());
  boxLayout->addWidget(closebox);

  crlfbox = new QCheckBox(i18n("Convert <LF> to <CR><LF>"), otherbox);
  crlfbox->setMinimumSize(crlfbox->sizeHint());
  boxLayout->addWidget(crlfbox);

  quotebox = new QCheckBox(i18n("Quote original message when replying"), otherbox);
  quotebox->setMinimumSize(quotebox->sizeHint());
  boxLayout->addWidget(quotebox);

  reconbox = new QCheckBox(i18n("Reconnect on disconnect"), otherbox);
  reconbox->setMinimumSize(reconbox->sizeHint());
  boxLayout->addWidget(reconbox);

  boxLayout->activate();
  topLayout->addWidget(otherbox);

  topLayout->addStretch(1);

  topLayout->activate();
}

void OtherWidget::setInfo(int rus, int closereply, int crlf, int quote, int recon)
{
  recodebox->setChecked(rus);
  closebox->setChecked(closereply);
  crlfbox->setChecked(crlf);
  quotebox->setChecked(quote);
  reconbox->setChecked(recon);
}

int OtherWidget::rus()
{
  return recodebox->isChecked();
}

int OtherWidget::closereply()
{
  return closebox->isChecked();
}

int OtherWidget::crlf()
{
  return crlfbox->isChecked();
}

int OtherWidget::quote()
{
  return quotebox->isChecked();
}

int OtherWidget::reconnect()
{
  return reconbox->isChecked();
}
