/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: prefqp.cpp,v 1.1 2000/05/24 16:59:04 denis Exp $
// $Log: prefqp.cpp,v $
// Revision 1.1  2000/05/24 16:59:04  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.4  2000/01/10 16:09:11  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//

#include <iostream.h>
#include <fstream.h>
#include <qlayout.h>
#include <qstring.h>
#include <kapp.h>

#include "prefbrowser.h"

#include "prefqp.moc"

QPPrefWidget::QPPrefWidget(QWidget *parent) : QWidget(parent)
{
  static char buf[1024];
  QString StringToAdd;
  int i = 0;

  QBoxLayout *topLayout = new QVBoxLayout(this);

  QLabel *mainlabel = new QLabel(i18n("10 sentences you use often in messages:"), this);
  mainlabel->setMinimumSize(mainlabel->sizeHint());
  topLayout->addWidget(mainlabel);

  topLayout->addSpacing(7);

  QGroupBox *groupbox = new QGroupBox(i18n("Enter QuickPhrases"), this);

  QBoxLayout *boxLayout = new QVBoxLayout(groupbox, 10, 7);

  boxLayout->addSpacing(7);

  edit = new QLineEdit(groupbox);
  edit->setMinimumSize(edit->sizeHint());
  edit->setMaximumHeight(edit->sizeHint().height());
  boxLayout->addWidget(edit, 1);

  QBoxLayout *butLayout = new QHBoxLayout(10);
  boxLayout->addLayout(butLayout);

  addbutton = new QPushButton(i18n("Add"), groupbox);
  connect(addbutton, SIGNAL(clicked()), this, SLOT(clickedAdd()));
  addbutton->setMinimumSize(addbutton->sizeHint());
  butLayout->addWidget(addbutton);

  deletebutton = new QPushButton(i18n("Delete"), groupbox);
  connect(deletebutton, SIGNAL(clicked()), this, SLOT(clickedDelete()));
  deletebutton->setMinimumSize(deletebutton->sizeHint());
  butLayout->addWidget(deletebutton);

  butLayout->addStretch(1);

  listbox = new QListBox(groupbox);
  connect(listbox, SIGNAL(highlighted(int)), this, SLOT(listboxItemChange(int)));

  ifstream instream(kapp->localkdedir() + "/share/apps/kicq/quickphrases");
  
  while(!instream.eof())
  {
    instream.getline(buf, sizeof buf - 1);
    if(instream.fail())
      break;
    else
    {
      i++;
      if(i > 10)
        break;
      StringToAdd = QString(buf);
      if(StringToAdd.stripWhiteSpace() != "")
        listbox->insertItem(StringToAdd);
    }
  }

  listbox->setMinimumHeight(150);
  listbox->setMinimumWidth(listbox->sizeHint().width());
  boxLayout->addWidget(listbox, 1);

  boxLayout->activate();
  topLayout->addWidget(groupbox, 1);

  topLayout->activate();
}

void QPPrefWidget::save()
{
  ofstream outstream(kapp->localkdedir() + "/share/apps/kicq/quickphrases");

  for(unsigned int i = 0; i < listbox->count(); i++)
  {
    outstream << listbox->text(i) << "\n";
  }
}

// FIXME: Add error message if count not < 10 ..
void QPPrefWidget::clickedAdd()
{
  if((listbox->count() < 10) && (QString(edit->text()).stripWhiteSpace() != ""))
  {
    listbox->insertItem(edit->text());
    edit->setText("");
  }
}

void QPPrefWidget::clickedDelete()
{
  if(listbox->currentItem() != -1)
  {
    listbox->removeItem(listbox->currentItem());
  }
}

// FIXME: Make a better implementation for this...
void QPPrefWidget::listboxItemChange(int item)
{
/*
  if (listbox->currentItem() != -1)
  {
  edit->setText(listbox->text(listbox->currentItem()));
  };
*/
}
