/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: prefserver.cpp,v 1.1 2000/05/24 16:59:04 denis Exp $
// $Log: prefserver.cpp,v $
// Revision 1.1  2000/05/24 16:59:04  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.9  2000/03/01 20:48:29  guruz
// -Added WGet as browser when recieving URLs
// -Modified server prefs
// -fixed some things with special ops
//
// Revision 1.8  2000/01/10 16:09:13  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.7  1999/12/02 14:32:44  denis
// Layout management implemented.
// Preferences dialog style switched from "Tabbed" dialog to
// "Netscape Preferences"-like style.
//
// Revision 1.6  1999/07/16 15:48:46  denis
// Cleaned up.
//
// Revision 1.5  1999/07/16 13:12:23  denis
// Internalization support added.
//
// Revision 1.4  1998/12/08 16:27:16  denis
// Cleaned up a little before releasing
//

#include <qlayout.h>
#include <kapp.h>

#include "prefserver.h"

#include "prefserver.moc"

ServerWidget::ServerWidget(QWidget *parent) : QWidget(parent)
{
  QBoxLayout *topLayout = new QVBoxLayout(this);

  QLabel *mainlabel = new QLabel(i18n("Enter Server Settings:"),this);
  mainlabel->setMinimumSize(mainlabel->sizeHint());
  topLayout->addWidget(mainlabel);

  topLayout->addSpacing(7);

  QGroupBox *serverbox = new QGroupBox(i18n("ICQ Server"), this);

  QBoxLayout *boxLayout = new QVBoxLayout(serverbox, 10, 7);

  boxLayout->addSpacing(7);

  QLabel *hostlabel = new QLabel(i18n("Server:"), serverbox);
  hostlabel->setMinimumSize(hostlabel->sizeHint());
  boxLayout->addWidget(hostlabel);

  hostline = new QComboBox(true,serverbox);
  hostline->setMinimumSize(hostline->sizeHint());
  hostline->setMaximumHeight(hostline->sizeHint().height());
  hostline->insertItem("icq1.mirabilis.com");
  hostline->insertItem("icq.mirabilis.com");
  hostline->insertItem("icq.fes.mirabilis.com");
  hostline->insertItem("205.188.179.39");
  hostline->insertItem("205.188.179.42");




  boxLayout->addWidget(hostline, 1);

  QLabel *portlabel = new QLabel(i18n("Port:"), serverbox);
  portlabel->setMinimumSize(portlabel->sizeHint());
  boxLayout->addWidget(portlabel);

  portline = new KIntegerLine(serverbox);
  portline->setMinimumSize(portline->sizeHint());
  portline->setMaximumHeight(portline->sizeHint().height());
  boxLayout->addWidget(portline, 1);

  boxLayout->activate();
  topLayout->addWidget(serverbox);

  topLayout->addStretch(1);

  topLayout->activate();
}

void ServerWidget::setInfo(const char *host, int port)
{
  hostline->setEditText(host);
  portline->setValue(port);
}

const char *ServerWidget::host()
{
  return hostline->currentText();
}

unsigned short ServerWidget::port()
{
  return portline->value();
}
