/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: prefuser.cpp,v 1.5 2000/07/11 17:42:26 denis Exp $
// $Log: prefuser.cpp,v $
// Revision 1.5  2000/07/11 17:42:26  denis
// Modification of UIN field was disabled again.
//
// Revision 1.4  2000/07/10 09:24:25  pcadach
// Recording of first-time registration information updated. See ChangeLog.
//
// Revision 1.3  2000/07/09 18:36:47  denis
// Modification of owner's UIN field disabled.
//
// Revision 1.2  2000/05/29 02:14:39  bills
// minor spelling/grammar fixes
//
// Revision 1.1  2000/05/24 16:59:04  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.7  2000/01/10 16:09:16  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.6  1999/12/02 14:32:48  denis
// Layout management implemented.
// Preferences dialog style switched from "Tabbed" dialog to
// "Netscape Preferences"-like style.
//
// Revision 1.5  1999/07/16 15:48:50  denis
// Cleaned up.
//
// Revision 1.4  1999/07/16 13:12:24  denis
// Internalization support added.
//
// Revision 1.3  1998/12/08 16:28:34  denis
// Cleaned up a little before releasing
//

#include <qlayout.h>
#include <kapp.h>

#include "prefuser.h"

#include "prefuser.moc"

UserWidget::UserWidget(QWidget *parent) : QWidget(parent)
{
  QBoxLayout *topLayout = new QVBoxLayout(this);

  QLabel *mainlabel = new QLabel(i18n("Enter Current User Settings:"),this);
  mainlabel->setMinimumSize(mainlabel->sizeHint());
  topLayout->addWidget(mainlabel);

  topLayout->addSpacing(7);

  QGroupBox *userbox = new QGroupBox(i18n("Current User Settings"), this);

  QBoxLayout *boxLayout = new QVBoxLayout(userbox, 10, 7);

  boxLayout->addSpacing(7);

  QLabel *uinlabel = new QLabel(i18n("ICQ#:"), userbox);
  uinlabel->setMinimumSize(uinlabel->sizeHint());
  boxLayout->addWidget(uinlabel);

  uinline = new KIntegerLine(userbox);
  uinline->setMinimumSize(uinline->sizeHint());
  uinline->setMaximumHeight(uinline->sizeHint().height());
  uinline->setFocusPolicy(QWidget::NoFocus);
  boxLayout->addWidget(uinline, 1);

  QLabel *nicklabel = new QLabel(i18n("Nickname:"), userbox);
  nicklabel->setMinimumSize(nicklabel->sizeHint());
  boxLayout->addWidget(nicklabel);

  nickline = new QLineEdit(userbox);
  nickline->setMinimumSize(nickline->sizeHint());
  nickline->setMaximumHeight(nickline->sizeHint().height());
  boxLayout->addWidget(nickline, 1);

  QLabel *passlabel = new QLabel(i18n("Password:"), userbox);
  passlabel->setMinimumSize(passlabel->sizeHint());
  boxLayout->addWidget(passlabel);

  passline = new QLineEdit(userbox);
  passline->setEchoMode(QLineEdit::Password);
  passline->setMinimumSize(passline->sizeHint());
  passline->setMaximumHeight(passline->sizeHint().height());
  boxLayout->addWidget(passline, 1);

  boxLayout->activate();
  topLayout->addWidget(userbox);

  topLayout->addStretch(1);

  topLayout->activate();
}

void UserWidget::setInfo(unsigned long uin, const char *nick, const char *pass)
{
  uinline->setValue(uin);
  nickline->setText(nick);
  passline->setText(pass);
}

unsigned long UserWidget::uin()
{
  return uinline->value();
}

const char *UserWidget::nick()
{
  return nickline->text();
}

const char *UserWidget::pass()
{
  return passline->text();
}
