/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: aboutwin.cpp,v 1.1 2000/07/21 19:28:41 denis Exp $
// $Log: aboutwin.cpp,v $
// Revision 1.1  2000/07/21 19:28:41  denis
// New User Registration Wizard was modified. Now it looks like original
// icq99b as much as possible (except page6)!
// New options on page7:
//   "Publish my online presence on the World Wide Web" and
//   "Do not publish IP address"
// Window for "Add your own personalized message" was added.
// Window for "More Email addresses" was added.
// Window for "For Tech Support" was added.
// Some work for error handling during registration was added.
//

#include <qlayout.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <kapp.h>

#include "aboutwin.h"

#include "aboutwin.moc"

AboutWindow::AboutWindow(QString about, QWidget *p) : QDialog(p, 0, TRUE)
{
  QBoxLayout *topLayout = new QVBoxLayout(this, 7);

  QLabel *label = new QLabel(
    i18n("Enter additional details about yourself (hobbies, favorite\n" \
         "links, your dog's name, etc.)"), this);
  label->setMinimumSize(label->sizeHint());
  topLayout->addWidget(label);

  aboutline = new QMultiLineEdit(this);
  aboutline->setMinimumSize(aboutline->fontMetrics().width("A")*40, aboutline->fontMetrics().height()*8);
  aboutline->setText(about);
  topLayout->addWidget(aboutline, 1);

  QBoxLayout *butLayout = new QHBoxLayout(7);
  topLayout->addLayout(butLayout);

  butLayout->addStretch(1);

  QPushButton *okbtn = new QPushButton(i18n("Ok"), this);
  okbtn->setMaximumHeight(okbtn->sizeHint().height());
  okbtn->setDefault(TRUE);
  okbtn->setMinimumSize(okbtn->sizeHint());
  connect(okbtn, SIGNAL(clicked()), SLOT(accept()));
  butLayout->addWidget(okbtn);

  butLayout->addStretch(1);

  topLayout->activate();
  aboutline->setFocus();

  setCaption(i18n("Enter free text"));

  resize(1,1);
}

QString AboutWindow::about()
{
  return aboutline->text();
}
