/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: emailswin.cpp,v 1.1 2000/07/21 19:28:41 denis Exp $
// $Log: emailswin.cpp,v $
// Revision 1.1  2000/07/21 19:28:41  denis
// New User Registration Wizard was modified. Now it looks like original
// icq99b as much as possible (except page6)!
// New options on page7:
//   "Publish my online presence on the World Wide Web" and
//   "Do not publish IP address"
// Window for "Add your own personalized message" was added.
// Window for "More Email addresses" was added.
// Window for "For Tech Support" was added.
// Some work for error handling during registration was added.
//

#include <qlayout.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qmessagebox.h>
#include <kapp.h>

#include "emailswin.h"

#include "emailswin.moc"

EMailsWindow::EMailsWindow(QString secondary, QString previous, QWidget *p) : QDialog(p, 0, TRUE)
{
  QBoxLayout *topLayout = new QVBoxLayout(this, 7);

  QLabel *label = new QLabel(
    i18n("You may enter additional Email addresses to be found by\n" \
         "such as your work address or previous address.\n\n" \
         "The 'Don't Publish My Email' option does not apply to the\n" \
         "following Email addresses, which will be published."), this);
  label->setMinimumSize(label->sizeHint());
  topLayout->addWidget(label, 1);

  QGridLayout *emailsLayout = new QGridLayout(2, 2, 7);
  topLayout->addLayout(emailsLayout);

  QLabel *secondaryLabel = new QLabel(i18n("Secondary Email:"), this);
  secondaryLabel->setMinimumSize(secondaryLabel->sizeHint());
  emailsLayout->addWidget(secondaryLabel, 0, 0);

  secondaryLine = new QLineEdit(this);
  secondaryLine->setMinimumSize(secondaryLine->sizeHint());
  secondaryLine->setFixedHeight(secondaryLine->sizeHint().height());
  secondaryLine->setText(secondary);
  emailsLayout->addWidget(secondaryLine, 0, 1);

  QLabel *previousLabel = new QLabel(i18n("Previous Email:"), this);
  previousLabel->setMinimumSize(previousLabel->sizeHint());
  emailsLayout->addWidget(previousLabel, 1, 0);

  previousLine = new QLineEdit(this);
  previousLine->setMinimumSize(previousLine->sizeHint());
  previousLine->setFixedHeight(previousLine->sizeHint().height());
  previousLine->setText(previous);
  emailsLayout->addWidget(previousLine, 1, 1);

  emailsLayout->setColStretch(1, 1);

  QBoxLayout *butLayout = new QHBoxLayout(7);
  topLayout->addLayout(butLayout);

  butLayout->addStretch(1);

  QPushButton *okbtn = new QPushButton(i18n("Ok"), this);
  okbtn->setMaximumHeight(okbtn->sizeHint().height());
  okbtn->setDefault(TRUE);
  connect(okbtn, SIGNAL(clicked()), SLOT(accept()));
  butLayout->addWidget(okbtn);

  QPushButton *cancelbtn = new QPushButton(i18n("Cancel"), this);
  cancelbtn->setMaximumHeight(cancelbtn->sizeHint().height());
  connect(cancelbtn, SIGNAL(clicked()), SLOT(reject()));
  butLayout->addWidget(cancelbtn);

  int w = QMAX(okbtn->sizeHint().width(), cancelbtn->sizeHint().width());
  okbtn->setMinimumSize(w, okbtn->sizeHint().height());
  cancelbtn->setMinimumSize(w, cancelbtn->sizeHint().height());

  butLayout->addStretch(1);

  topLayout->activate();

  setCaption(i18n("Other Email Addresses"));

  resize(1,1);
}

QString EMailsWindow::secondary()
{
  return secondaryLine->text();
}

QString EMailsWindow::previous()
{
  return previousLine->text();
}

void EMailsWindow::accept()
{
  QString email2 = secondaryLine->text();
  if(!email2.isEmpty())
  {
    if(email2.find('@')<0 || email2.find('@')==0 || (unsigned)email2.find('@')==email2.length()-1)
    {
      QMessageBox::critical(this, i18n("Error"), i18n("Not a valid e-mail address"));
      return;
    }
  }
  QString email3 = secondaryLine->text();
  if(!email3.isEmpty())
  {
    if(email3.find('@')<0 || email3.find('@')==0 || (unsigned)email3.find('@')==email3.length()-1)
    {
      QMessageBox::critical(this, i18n("Error"), i18n("Not a valid e-mail address"));
      return;
    }
  }
  QDialog::accept();
}
