/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * $Id: page2.cpp,v 1.1 2000/06/25 17:59:10 denis Exp $
 * $Log: page2.cpp,v $
 * Revision 1.1  2000/06/25 17:59:10  denis
 * RegWindow constructor was splitted to several files, by one on every
 * page.
 * Some debugging code along with useful one were added - trying to catch
 * up this stupid segfault in RegWindow...
 *
 */

#include "regwin.h"

void RegWindow::setupPage2()
{
//---------------------------------------------------
  QWidget *page2 = new QWidget(rightPanel);
  panelLayout->addWidget(page2, 0, 0);
  QBoxLayout *p2Layout = new QVBoxLayout(page2, 0, 5);

  QLabel *p2Label1 = new QLabel(i18n("Firewall Settings"), page2);
  p2Label1->setAlignment(AlignCenter);
  p2Label1->setMinimumSize(p2Label1->sizeHint());
  p2Layout->addWidget(p2Label1);

  QLabel *p2Label2 = new QLabel(i18n(
    "Please consult your administrator regarding\n"\
    "firewall/proxy settings."), page2);
  p2Label2->setMinimumSize(p2Label2->sizeHint());
  p2Layout->addWidget(p2Label2);

  QLabel *p2Label3 = new QLabel(i18n(
    "It is advisable to use a SOCKS Proxy server if your\n"\
    "firewall blocks TCP/UDP packets."), page2);
  p2Label3->setMinimumSize(p2Label3->sizeHint());
  p2Layout->addWidget(p2Label3);

  QButtonGroup *p2Box = new QButtonGroup(i18n(
    "Specify what SOCKS Proxy server do you use:"), page2);

  QBoxLayout *p2BoxLayout = new QVBoxLayout(p2Box, 10, 5);
  p2BoxLayout->addSpacing(7);

  p2ProxyBtn = new QRadioButton(i18n(
    "I don't use a SOCKS Proxy server on my firewall\n"\
    "or I am using another Proxy server"), p2Box);
  p2ProxyBtn->setMinimumSize(p2ProxyBtn->sizeHint());
  p2ProxyBtn->setChecked(TRUE);
  p2Box->insert(p2ProxyBtn);
  p2BoxLayout->addWidget(p2ProxyBtn);

  p2SocksBtn = new QRadioButton(i18n(
    "I am using a SOCKS5 Proxy server"), p2Box);
  p2SocksBtn->setMinimumSize(p2SocksBtn->sizeHint());
  p2SocksBtn->setChecked(FALSE);
  p2Box->insert(p2SocksBtn);
  p2BoxLayout->addWidget(p2SocksBtn);

  p2BoxLayout->activate();

  p2Layout->addWidget(p2Box, 1);

  QBoxLayout *p2TMLayout = new QHBoxLayout(5);
  p2Layout->addLayout(p2TMLayout);

  p2TimeOut = new QCheckBox(i18n(
    "Firewall sessions\n"\
    "time out after"), page2);
  p2TimeOut->setMinimumSize(p2TimeOut->sizeHint());
  p2TimeOut->setChecked(FALSE);
  p2TMLayout->addWidget(p2TimeOut);

  p2TMLine = new QSpinBox(0, 900, 1, page2);
  p2TMLine->setFixedWidth(60);
  p2TMLine->setFixedHeight(p2TMLine->sizeHint().height());
  p2TMLine->setValue(120);
  p2TMLine->setEnabled(FALSE);
  p2TMLayout->addWidget(p2TMLine);

  QLabel *p2TMLabel = new QLabel(i18n("seconds of inactivity"), page2);
  p2TMLabel->setMinimumSize(p2TMLabel->sizeHint());
  p2TMLayout->addWidget(p2TMLabel, 1);

  connect(p2TimeOut, SIGNAL(toggled(bool)), SLOT(slotP2TimeOut(bool)));

  p2Layout->activate();
  pageList.append(page2);
}
