/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * $Id: page5.cpp,v 1.3 2000/07/24 19:02:29 denis Exp $
 * $Log: page5.cpp,v $
 * Revision 1.3  2000/07/24 19:02:29  denis
 * Cleanups.
 *
 * Revision 1.2  2000/07/21 19:28:41  denis
 * New User Registration Wizard was modified. Now it looks like original
 * icq99b as much as possible (except page6)!
 * New options on page7:
 *   "Publish my online presence on the World Wide Web" and
 *   "Do not publish IP address"
 * Window for "Add your own personalized message" was added.
 * Window for "More Email addresses" was added.
 * Window for "For Tech Support" was added.
 * Some work for error handling during registration was added.
 *
 * Revision 1.1  2000/06/25 17:59:10  denis
 * RegWindow constructor was splitted to several files, by one on every
 * page.
 * Some debugging code along with useful one were added - trying to catch
 * up this stupid segfault in RegWindow...
 *
 */

#include "regwin.h"

void RegWindow::setupPage5()
{
//---------------------------------------------------
  QWidget *page5 = new QWidget(rightPanel);
  panelLayout->addWidget(page5, 0, 0);
  QBoxLayout *p5Layout = new QVBoxLayout(page5, 0, 5);

  QGroupBox *p5DetBox = new QGroupBox(i18n("Essential Details"), page5);

  QBoxLayout *p5DetBoxLayout = new QVBoxLayout(p5DetBox, 10, 5);
  p5DetBoxLayout->addSpacing(7);

  QLabel *p5Label1 = new QLabel(i18n(
    "Entering the following details will enable you to be easily found\n"\
    "by other users. Details will be published in ICQ and associated\n"\
    "directories. You may choose to leave some or all details blank."), p5DetBox);
  p5Label1->setMinimumSize(p5Label1->sizeHint());
  p5DetBoxLayout->addWidget(p5Label1);

  QGridLayout *p5GridLayout = new QGridLayout(9, 5, 0);
  p5DetBoxLayout->addLayout(p5GridLayout, 1);

  QLabel *p5FirstLabel = new QLabel(i18n("First Name:"), p5DetBox);
  p5FirstLabel->setMinimumSize(p5FirstLabel->sizeHint());
  p5GridLayout->addWidget(p5FirstLabel, 1, 0);

  p5FirstLine = new QLineEdit(p5DetBox);
  p5FirstLine->setMinimumSize(p5FirstLine->sizeHint());
  p5FirstLine->setFixedHeight(p5FirstLine->sizeHint().height());
  p5GridLayout->addWidget(p5FirstLine, 1, 2);

  QLabel *p5LastLabel = new QLabel(i18n("Last Name:"), p5DetBox);
  p5LastLabel->setMinimumSize(p5LastLabel->sizeHint());
  p5GridLayout->addWidget(p5LastLabel, 3, 0);

  p5LastLine = new QLineEdit(p5DetBox);
  p5LastLine->setMinimumSize(p5LastLine->sizeHint());
  p5LastLine->setFixedHeight(p5LastLine->sizeHint().height());
  p5GridLayout->addWidget(p5LastLine, 3, 2);

  QLabel *p5NickLabel = new QLabel(i18n("Nickname: (list name)"), p5DetBox);
  p5NickLabel->setMinimumSize(p5NickLabel->sizeHint());
  p5GridLayout->addWidget(p5NickLabel, 5, 0);

  p5NickLine = new QLineEdit(p5DetBox);
  p5NickLine->setMinimumSize(p5NickLine->sizeHint());
  p5NickLine->setFixedHeight(p5NickLine->sizeHint().height());
  p5GridLayout->addWidget(p5NickLine, 5, 2);

  QLabel *p5EmailLabel = new QLabel(i18n("Email: (i.e. john@isp...)"), p5DetBox);
  p5EmailLabel->setMinimumSize(p5EmailLabel->sizeHint());
  p5GridLayout->addWidget(p5EmailLabel, 7, 0);

  p5EmailLine = new QLineEdit(p5DetBox);
  p5EmailLine->setMinimumSize(p5EmailLine->sizeHint());
  p5EmailLine->setFixedHeight(p5EmailLine->sizeHint().height());
  connect(p5EmailLine, SIGNAL(textChanged(const char*)), SLOT(slotP5EmailLine(const char*)));
  p5GridLayout->addWidget(p5EmailLine, 7, 2);

  p5EmailsBtn = new QPushButton(i18n("More Email\naddresses"), p5DetBox);
  p5EmailsBtn->setMinimumHeight(p5EmailsBtn->sizeHint().height());
  int w = QMAX(p5EmailsBtn->fontMetrics().width(i18n("More Email")),
               p5EmailsBtn->fontMetrics().width(i18n("addresses")));
  p5EmailsBtn->setMinimumWidth(w+10);
  p5EmailsBtn->setEnabled(FALSE);
  connect(p5EmailsBtn, SIGNAL(clicked()), SLOT(slotP5EmailsBtn()));
  p5GridLayout->addMultiCellWidget(p5EmailsBtn, 5, 7, 4, 4);

  p5GridLayout->addColSpacing(1, 5);
  p5GridLayout->addColSpacing(3, 5);
  p5GridLayout->setColStretch(2, 1);
  p5GridLayout->addRowSpacing(2, 5);
  p5GridLayout->addRowSpacing(4, 5);
  p5GridLayout->addRowSpacing(6, 5);
  p5GridLayout->setRowStretch(0, 1);
  p5GridLayout->setRowStretch(2, 1);
  p5GridLayout->setRowStretch(4, 1);
  p5GridLayout->setRowStretch(6, 1);
  p5GridLayout->setRowStretch(8, 1);

  p5HideEml = new QCheckBox(i18n(
    "Don't publish my email address. Use for password retieval\n"\
    "purposes"), p5DetBox);
  p5HideEml->setMinimumSize(p5HideEml->sizeHint());
  p5HideEml->setChecked(FALSE);
  p5DetBoxLayout->addWidget(p5HideEml);

  QLabel *p5Label2 = new QLabel(i18n(
    "Note: In case your password is lost, the Email address written\n"\
    "in your details is the only address the password can be Emailed\n"\
    "to. It is therefore recommended to enter a valid Email address."), p5DetBox);
  p5Label2->setMinimumSize(p5Label2->sizeHint());
  p5DetBoxLayout->addWidget(p5Label2);

  p5DetBoxLayout->activate();

  p5Layout->addWidget(p5DetBox, 1);

  p5Layout->activate();
  pageList.append(page5);
}
