/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * $Id: page6.cpp,v 1.3 2000/07/21 19:28:41 denis Exp $
 * $Log: page6.cpp,v $
 * Revision 1.3  2000/07/21 19:28:41  denis
 * New User Registration Wizard was modified. Now it looks like original
 * icq99b as much as possible (except page6)!
 * New options on page7:
 *   "Publish my online presence on the World Wide Web" and
 *   "Do not publish IP address"
 * Window for "Add your own personalized message" was added.
 * Window for "More Email addresses" was added.
 * Window for "For Tech Support" was added.
 * Some work for error handling during registration was added.
 *
 * Revision 1.2  2000/07/11 17:37:31  denis
 * const char* changed to QString for kde2 compatibility.
 *
 * Revision 1.1  2000/06/25 17:59:10  denis
 * RegWindow constructor was splitted to several files, by one on every
 * page.
 * Some debugging code along with useful one were added - trying to catch
 * up this stupid segfault in RegWindow...
 *
 */

#include "regwin.h"

typedef struct 
{
  QString name;
  unsigned short code;
} cgItem;

void RegWindow::setupPage6()
{
//---------------------------------------------------
  QWidget *page6 = new QWidget(rightPanel);
  panelLayout->addWidget(page6, 0, 0);
  QBoxLayout *p6Layout = new QVBoxLayout(page6, 0, 5);

  QLabel *p6Label1 = new QLabel(i18n("Optional details:"), page6);
  p6Label1->setMinimumSize(p6Label1->sizeHint());
  p6Layout->addWidget(p6Label1);

  QGroupBox *p6LocBox = new QGroupBox(i18n("Location"), page6);

  QBoxLayout *p6LocBoxLayout = new QVBoxLayout(p6LocBox, 10, 5);
  p6LocBoxLayout->addSpacing(7);

  QBoxLayout *p6CityLayout = new QHBoxLayout(5);
  p6LocBoxLayout->addLayout(p6CityLayout);

  QLabel *p6CityLabel = new QLabel(i18n("City:"), p6LocBox);
  p6CityLabel->setMinimumSize(p6CityLabel->sizeHint());
  p6CityLayout->addWidget(p6CityLabel);

  p6CityLine = new QLineEdit(p6LocBox);
  p6CityLine->setMinimumSize(p6CityLine->sizeHint());
  p6CityLine->setFixedHeight(p6CityLine->sizeHint().height());
  p6CityLayout->addWidget(p6CityLine, 1);

  QBoxLayout *p6StateLayout = new QHBoxLayout(5);
  p6LocBoxLayout->addLayout(p6StateLayout);

  QLabel *p6StateLabel = new QLabel(i18n("State:"), p6LocBox);
  p6StateLabel->setMinimumSize(p6StateLabel->sizeHint());
  p6StateLayout->addWidget(p6StateLabel);

  p6StateLine = new QLineEdit(p6LocBox);
  p6StateLine->setMaxLength(2);
  p6StateLine->setMinimumWidth(60);
  p6StateLine->setFixedHeight(p6StateLine->sizeHint().height());
  p6StateLayout->addWidget(p6StateLine, 1);

  QLabel *p6CountryLabel = new QLabel(i18n("Country:"), p6LocBox);
  p6CountryLabel->setMinimumSize(p6CountryLabel->sizeHint());
  p6StateLayout->addWidget(p6CountryLabel);

  p6CountryLine = new QComboBox(FALSE, p6LocBox);
  p6CountryLine->setFixedHeight(p6CountryLine->sizeHint().height());
  QStrList ctrList;
  ctrList.inSort("");

  for(int i=0; icq_Countries[i].code!=0xffff; i++)
    ctrList.inSort(icq_Countries[i].name);

//  p6CountryLine->insertItem(kCountry_Codes[i++].name);
  p6CountryLine->insertStrList(&ctrList);
  p6CountryLine->setMinimumSize(p6CountryLine->sizeHint());
  p6StateLayout->addWidget(p6CountryLine);

  p6LocBoxLayout->activate();

  p6Layout->addWidget(p6LocBox, 1);

  QGroupBox *p6ExtraBox = new QGroupBox(i18n("Extra Details"), page6);

  QBoxLayout *p6ExtraBoxLayout = new QVBoxLayout(p6ExtraBox, 10, 5);
  p6ExtraBoxLayout->addSpacing(7);

  QBoxLayout *p6AgeLayout = new QHBoxLayout(5);
  p6ExtraBoxLayout->addLayout(p6AgeLayout);

  QLabel *p6AgeLabel = new QLabel(i18n("Age:"), p6ExtraBox);
  p6AgeLabel->setMinimumSize(p6AgeLabel->sizeHint());
  p6AgeLayout->addWidget(p6AgeLabel);

  p6AgeLine = new KIntegerLine(p6ExtraBox);
  p6AgeLine->setMinimumSize(p6AgeLine->sizeHint());
  p6AgeLine->setFixedHeight(p6AgeLine->sizeHint().height());
  p6AgeLayout->addWidget(p6AgeLine, 1);

  QLabel *p6GenderLabel = new QLabel(i18n("Gender:"), p6ExtraBox);
  p6GenderLabel->setMinimumSize(p6GenderLabel->sizeHint());
  p6AgeLayout->addWidget(p6GenderLabel);

  cgItem Gender_Codes[] = {
    {i18n("Not Specified"), 0},
    {i18n("Female"), 1},
    {i18n("Male"), 2},
    {"", 0xFFFF}};

  QComboBox *p6GenderLine = new QComboBox(FALSE, p6ExtraBox);
  p6GenderLine->setFixedHeight(p6GenderLine->sizeHint().height());
  int i = 0;
  while(Gender_Codes[i].code!=0xFFFF)
    p6GenderLine->insertItem(Gender_Codes[i++].name);
  p6GenderLine->setMinimumSize(p6GenderLine->sizeHint());
  p6AgeLayout->addWidget(p6GenderLine);

  QBoxLayout *p6PhoneLayout = new QHBoxLayout(5);
  p6ExtraBoxLayout->addLayout(p6PhoneLayout);

  QLabel *p6PhoneLabel = new QLabel(i18n("Telephone:"), p6ExtraBox);
  p6PhoneLabel->setMinimumSize(p6PhoneLabel->sizeHint());
  p6PhoneLayout->addWidget(p6PhoneLabel);

  p6PhoneLine = new QLineEdit(p6ExtraBox);
  p6PhoneLine->setMinimumSize(p6PhoneLine->sizeHint());
  p6PhoneLine->setFixedHeight(p6PhoneLine->sizeHint().height());
  p6PhoneLayout->addWidget(p6PhoneLine, 1);

  QBoxLayout *p6PageLayout = new QHBoxLayout(5);
  p6ExtraBoxLayout->addLayout(p6PageLayout);

  QLabel *p6PageLabel = new QLabel(i18n("HomePage:"), p6ExtraBox);
  p6PageLabel->setMinimumSize(p6PageLabel->sizeHint());
  p6PageLayout->addWidget(p6PageLabel);

  p6PageLine = new QLineEdit(p6ExtraBox);
  p6PageLine->setMinimumSize(p6PageLine->sizeHint());
  p6PageLine->setFixedHeight(p6PageLine->sizeHint().height());
  p6PageLayout->addWidget(p6PageLine, 1);

  QBoxLayout *p6AboutLayout = new QHBoxLayout(5);
  p6ExtraBoxLayout->addLayout(p6AboutLayout);

  QLabel *p6AboutLabel = new QLabel(i18n("About:"), p6ExtraBox);
  p6AboutLabel->setMinimumSize(p6AboutLabel->sizeHint());
  p6AboutLayout->addWidget(p6AboutLabel);

  QPushButton *p6AboutBtn = new QPushButton(i18n("Add your own personalized message."), p6ExtraBox);
  p6AboutBtn->setMinimumSize(p6AboutBtn->sizeHint());
  p6AboutBtn->setFixedHeight(p6AboutBtn->sizeHint().height());
  connect(p6AboutBtn, SIGNAL(clicked()), SLOT(slotP6AboutBtn()));
  p6AboutLayout->addWidget(p6AboutBtn, 1);

  p6ExtraBoxLayout->activate();

  p6Layout->addWidget(p6ExtraBox, 1);

  p6Layout->activate();
  pageList.append(page6);
}
