/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * $Id: page7.cpp,v 1.2 2000/07/21 19:28:41 denis Exp $
 * $Log: page7.cpp,v $
 * Revision 1.2  2000/07/21 19:28:41  denis
 * New User Registration Wizard was modified. Now it looks like original
 * icq99b as much as possible (except page6)!
 * New options on page7:
 *   "Publish my online presence on the World Wide Web" and
 *   "Do not publish IP address"
 * Window for "Add your own personalized message" was added.
 * Window for "More Email addresses" was added.
 * Window for "For Tech Support" was added.
 * Some work for error handling during registration was added.
 *
 * Revision 1.1  2000/06/25 17:59:10  denis
 * RegWindow constructor was splitted to several files, by one on every
 * page.
 * Some debugging code along with useful one were added - trying to catch
 * up this stupid segfault in RegWindow...
 *
 */

#include "regwin.h"

void RegWindow::setupPage7()
{
//---------------------------------------------------
  QWidget *page7 = new QWidget(rightPanel);
  panelLayout->addWidget(page7, 0, 0);
  QBoxLayout *p7Layout = new QVBoxLayout(page7, 0, 5);

  QGroupBox *p7SecurBox = new QGroupBox(i18n("Password Protection"), page7);

  QBoxLayout *p7SecurBoxLayout = new QVBoxLayout(p7SecurBox, 10, 5);
  p7SecurBoxLayout->addSpacing(7);

  QLabel *p7SecurLabel = new QLabel(i18n(
    "Choose a password to protect your personal ICQ Number:"), p7SecurBox);
  p7SecurLabel->setMinimumSize(p7SecurLabel->sizeHint());
  p7SecurBoxLayout->addWidget(p7SecurLabel);

  QGridLayout *p7GridLayout = new QGridLayout(5, 5, 0);
  p7SecurBoxLayout->addLayout(p7GridLayout, 1);

  QLabel *p7PassLabel = new QLabel(i18n("Password:"), p7SecurBox);
  p7PassLabel->setMinimumSize(p7PassLabel->sizeHint());
  p7GridLayout->addWidget(p7PassLabel, 1, 0, AlignVCenter);

  p7PassLine = new QLineEdit(p7SecurBox);
  p7PassLine->setMinimumSize(p7PassLine->sizeHint());
  p7PassLine->setFixedHeight(p7PassLine->sizeHint().height());
  p7PassLine->setEchoMode(QLineEdit::Password);
  p7GridLayout->addWidget(p7PassLine, 1, 2, AlignVCenter);

  QLabel *p7ConfirmLabel = new QLabel(i18n("Confirm\nPassword:"), p7SecurBox);
  p7ConfirmLabel->setMinimumSize(p7ConfirmLabel->sizeHint());
  p7GridLayout->addWidget(p7ConfirmLabel, 3, 0, AlignVCenter);

  p7ConfirmLine = new QLineEdit(p7SecurBox);
  p7ConfirmLine->setMinimumSize(p7ConfirmLine->sizeHint());
  p7ConfirmLine->setFixedHeight(p7ConfirmLine->sizeHint().height());
  p7ConfirmLine->setEchoMode(QLineEdit::Password);
  p7GridLayout->addWidget(p7ConfirmLine, 3, 2, AlignVCenter);

  QCheckBox *p7SaveBtn = new QCheckBox(i18n("Auto Save\nPassword"), p7SecurBox);
  p7SaveBtn->setMinimumSize(p7SaveBtn->sizeHint());
  p7SaveBtn->setFixedHeight(p7SaveBtn->sizeHint().height());
  p7SaveBtn->setChecked(TRUE);
  p7GridLayout->addMultiCellWidget(p7SaveBtn, 1, 3, 4, 4, AlignCenter);

  p7GridLayout->setColStretch(2, 1);
  p7GridLayout->addColSpacing(1, 5);
  p7GridLayout->addColSpacing(3, 5);
  p7GridLayout->addRowSpacing(2, 5);
  p7GridLayout->addRowSpacing(4, 5);
  p7GridLayout->setRowStretch(0, 1);
  p7GridLayout->setRowStretch(2, 1);
  p7GridLayout->setRowStretch(4, 1);
  p7SecurBoxLayout->activate();

  p7Layout->addWidget(p7SecurBox, 1);

  QButtonGroup *p7PrivBox = new QButtonGroup(i18n("Privacy Level"), page7);

  QBoxLayout *p7PrivBoxLayout = new QVBoxLayout(p7PrivBox, 10, 5);
  p7PrivBoxLayout->addSpacing(7);

  QLabel *p7PrivLabel = new QLabel(i18n(
    "You may choose to be seen (and contacted) by all users,\n"\
    "or only by those whom you authorize."), p7PrivBox);
  p7PrivLabel->setMinimumSize(p7PrivLabel->sizeHint());
  p7PrivBoxLayout->addWidget(p7PrivLabel);

  QRadioButton *p7AllBtn = new QRadioButton(i18n(
    "Anyone may contact me and see when I'm online."), p7PrivBox);
  p7AllBtn->setMinimumSize(p7AllBtn->sizeHint());
  p7AllBtn->setChecked(TRUE);
  p7PrivBox->insert(p7AllBtn);
  p7PrivBoxLayout->addWidget(p7AllBtn, 1);

  p7AuthBtn = new QRadioButton(i18n(
    "My authorization is required."), p7PrivBox);
  p7AuthBtn->setMinimumSize(p7AuthBtn->sizeHint());
  p7AuthBtn->setChecked(FALSE);
  p7PrivBox->insert(p7AuthBtn);
  p7PrivBoxLayout->addWidget(p7AuthBtn, 1);

  p7PrivBoxLayout->activate();

  p7Layout->addWidget(p7PrivBox, 1);

  QButtonGroup *p7OtherBox = new QButtonGroup(i18n("Other Options"), page7);

  QBoxLayout *p7OtherBoxLayout = new QVBoxLayout(p7OtherBox, 10, 5);
  p7OtherBoxLayout->addSpacing(7);

  p7WebAwareBtn = new QCheckBox(i18n(
    "Publish my online presence on the World Wide Web"), p7OtherBox);
  p7WebAwareBtn->setMinimumSize(p7WebAwareBtn->sizeHint());
  p7WebAwareBtn->setChecked(TRUE);
  p7OtherBox->insert(p7WebAwareBtn);
  p7OtherBoxLayout->addWidget(p7WebAwareBtn, 1);

  p7HideIPBtn = new QCheckBox(i18n(
    "Do not publish IP address"), p7OtherBox);
  p7HideIPBtn->setMinimumSize(p7HideIPBtn->sizeHint());
  p7HideIPBtn->setChecked(FALSE);
  p7OtherBox->insert(p7HideIPBtn);
  p7OtherBoxLayout->addWidget(p7HideIPBtn, 1);

  p7OtherBoxLayout->activate();

  p7Layout->addWidget(p7OtherBox, 1);

  p7Layout->activate();
  pageList.append(page7);
}
