/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * $Id: page8.cpp,v 1.3 2000/07/22 17:00:33 denis Exp $
 * $Log: page8.cpp,v $
 * Revision 1.3  2000/07/22 17:00:33  denis
 * Registration error handling was hopefully finished.
 *
 * Revision 1.2  2000/07/21 19:28:41  denis
 * New User Registration Wizard was modified. Now it looks like original
 * icq99b as much as possible (except page6)!
 * New options on page7:
 *   "Publish my online presence on the World Wide Web" and
 *   "Do not publish IP address"
 * Window for "Add your own personalized message" was added.
 * Window for "More Email addresses" was added.
 * Window for "For Tech Support" was added.
 * Some work for error handling during registration was added.
 *
 * Revision 1.1  2000/06/25 17:59:10  denis
 * RegWindow constructor was splitted to several files, by one on every
 * page.
 * Some debugging code along with useful one were added - trying to catch
 * up this stupid segfault in RegWindow...
 *
 */

#include <qmovie.h>

#include "regwin.h"

void RegWindow::setupPage8()
{
//---------------------------------------------------
  QWidget *page8 = new QWidget(rightPanel);
  panelLayout->addWidget(page8, 0, 0);
  QBoxLayout *p8Layout = new QVBoxLayout(page8, 0, 5);

  QGroupBox *p8StatusBox = new QGroupBox(i18n("Registration Status"), page8);

  QBoxLayout *p8BoxLayout = new QVBoxLayout(p8StatusBox, 10, 5);
  p8BoxLayout->addSpacing(7);

  QLabel *p8Label1 = new QLabel(i18n(
    "Your information is being registered at the ICQ network.\n"\
    "Your own Universal Internet Number is being assigned."), p8StatusBox);
  p8Label1->setMinimumSize(p8Label1->sizeHint());
  p8BoxLayout->addWidget(p8Label1);

  QBoxLayout *p8LabelLayout = new QHBoxLayout(10);
  p8BoxLayout->addLayout(p8LabelLayout);

  p8StatusLabel = new QLabel(i18n("Registering User"), p8StatusBox);
  p8StatusLabel->setAlignment(AlignCenter);
  p8StatusLabel->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
  p8StatusLabel->setMinimumSize(p8StatusLabel->sizeHint());
  p8StatusLabel->setFixedHeight(p8StatusLabel->sizeHint().height());
  p8LabelLayout->addWidget(p8StatusLabel, 1);

  p8SpinLabel = new QLabel(p8StatusBox);
  p8SpinLabel->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
  p8SpinLabel->setAlignment(AlignCenter);
  p8SpinLabel->setMargin(0);
  QString spinfn = kapp->localkdedir()+"/share/apps/"+kapp->appName()+"/pics/search.gif";
  QFile testfile(spinfn);
  if(!testfile.exists())
    spinfn = kapp->kde_datadir()+"/"+kapp->appName()+"/pics/search.gif";
  p8SpinLabel->setMovie(QMovie((const char*)spinfn));
  p8SpinLabel->movie()->pause();
  p8SpinLabel->movie()->restart();
  p8SpinLabel->setFixedSize(36, 36);
  p8LabelLayout->addWidget(p8SpinLabel);

  p8BoxLayout->activate();

  p8Layout->addWidget(p8StatusBox);

  p8Layout->addStretch(1);

  QGridLayout *p8FailLayout = new QGridLayout(2, 4, 5);
  p8Layout->addLayout(p8FailLayout);

  p8RetryBtn = new QPushButton(i18n("Retry"), page8);
  p8RetryBtn->setMinimumSize(p8RetryBtn->sizeHint());
  p8RetryBtn->hide();
  connect(p8RetryBtn, SIGNAL(clicked()), SLOT(slotP8RetryBtn()));
  p8FailLayout->addWidget(p8RetryBtn, 0, 1);

  p8RetryLabel = new QLabel(i18n("- Retry to register again"), page8);
  p8RetryLabel->setMinimumSize(p8RetryLabel->sizeHint());
  p8RetryLabel->hide();
  p8FailLayout->addWidget(p8RetryLabel, 0, 2);

  p8FirewallBtn = new QPushButton(i18n("Firewall"), page8);
  p8FirewallBtn->setMinimumSize(p8FirewallBtn->sizeHint());
  p8FirewallBtn->hide();
  connect(p8FirewallBtn, SIGNAL(clicked()), SLOT(slotP8FirewallBtn()));
  p8FailLayout->addWidget(p8FirewallBtn, 1, 1);

  p8FirewallLabel = new QLabel(i18n(
    "In case you are working behind a firewall\n" \
    "- set parameters."), page8);
  p8FirewallLabel->setMinimumSize(p8FirewallLabel->sizeHint());
  p8FirewallLabel->hide();
  p8FailLayout->addWidget(p8FirewallLabel, 1, 2, AlignVCenter);

  p8FailLayout->setColStretch(0, 1);
  p8FailLayout->setColStretch(3, 1);

  p8Layout->addStretch(1);

  p8Layout->activate();
  pageList.append(page8);
}
