/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: regwin.h,v 1.5 2000/07/22 17:00:33 denis Exp $

#ifndef _REGWIN_H_
#define _REGWIN_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qdialog.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qcombobox.h>
#include <qlist.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <qspinbox.h>
#include <qsocketnotifier.h>
#include <qframe.h>
#include <qbuttongroup.h>
#include <qgroupbox.h>
#include <qmessagebox.h>
#include <kiconloader.h>
#include <kapp.h>
#include <kseparator.h>
#include <kintegerline.h>
#include <icq.h>

typedef struct ackNumS
{
  unsigned short num;
  ackNumS(unsigned short n) : num(n) {}
  ~ackNumS() {}
} ackNum;

class RegWindow : public QDialog
{
  Q_OBJECT
public:
  RegWindow(QWidget*);
  virtual ~RegWindow();
public slots:
signals:
protected:
  int curPage;
  QString icqServer;
  unsigned short icqPort;
  QString aboutInfo, secondaryEmail, previousEmail;
  int icqSocket, icqProxySocket;
  QSocketNotifier *icqSN, *icqProxySN;
  QGridLayout *panelLayout;
  QWidget *rightPanel;
  QPushButton *backBtn, *nextBtn;
  QList<QWidget> pageList;
  QRadioButton *p0NewBtn, *p0ExistBtn;
  QRadioButton *p1LanBtn, *p1FWNoBtn, *p1FWYesBtn, *p1ModemBtn;
  QRadioButton *p2ProxyBtn, *p2SocksBtn;
  QCheckBox *p2TimeOut;
  QSpinBox *p2TMLine;
  QLineEdit *p3HostLine, *p3NameLine, *p3PassLine;
  KIntegerLine *p3PortLine;
  QCheckBox *p3rfcBtn;
  KIntegerLine *p4UINLine;
  QLineEdit *p4PassLine;
  QLineEdit *p5EmailLine, *p5NickLine, *p5FirstLine, *p5LastLine;
  QCheckBox *p5HideEml;
  QPushButton *p5EmailsBtn;
  KIntegerLine *p6AgeLine;
  QComboBox *p6CountryLine;
  QLineEdit *p6CityLine, *p6StateLine, *p6PhoneLine, *p6PageLine;
  QLineEdit *p7PassLine, *p7ConfirmLine;
  QRadioButton *p7AuthBtn;
  QCheckBox *p7WebAwareBtn, *p7HideIPBtn;
  QLabel *p8SpinLabel, *p8StatusLabel;
  QPushButton *p8RetryBtn, *p8FirewallBtn;
  QLabel *p8RetryLabel, *p8FirewallLabel;
  QTimer *libTimer;
  bool icqinit;
  unsigned long uin;
  QList<ackNum> ackList;
  ICQLINK icqlink;

  void setPage(int);
  void newLogin(unsigned long);
  void updateInfo();
  void existUINisOK();
  void ackSrv(unsigned short);
  void registerUIN();
  void saveNewUIN();
  void saveExistUIN();
  void disconnect();
  void showStatus(QString);
  void stop(bool);

  void setupPage0();
  void setupPage1();
  void setupPage2();
  void setupPage3();
  void setupPage4();
  void setupPage5();
  void setupPage6();
  void setupPage7();
  void setupPage8();

  // Callbacks
  static void loggedIn(ICQLINK*);
  static void loggedInExist(ICQLINK*);
  static void disconnected(ICQLINK*);
  static void newUIN(ICQLINK*, unsigned long);
  static void requestNotify(ICQLINK*, unsigned long, int, unsigned int, void*);
  static void wrongPasswd(ICQLINK*);
  static void invalidUIN(ICQLINK*);
  static void setTimeout(ICQLINK*, long);
  static void logEvent(ICQLINK*, time_t, unsigned char, const char*);
protected slots:
  void nextPage();
  void prevPage();
  void slotP1LanBtn(bool);
  void slotP2TimeOut(bool);
  void slotP3rfcBtn(bool);
  void slotP5EmailLine(const char*);
  void slotP5EmailsBtn();
  void slotP6AboutBtn();
  void slotP8RetryBtn();
  void slotP8FirewallBtn();
  void slotTechBtn();
  void dataReceived(int);
  void done(int r);
  void libTimerDone();
private:
private slots:
};

#endif /* _REGWIN_H_ */
