/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: techwin.cpp,v 1.1 2000/07/21 19:28:41 denis Exp $
// $Log: techwin.cpp,v $
// Revision 1.1  2000/07/21 19:28:41  denis
// New User Registration Wizard was modified. Now it looks like original
// icq99b as much as possible (except page6)!
// New options on page7:
//   "Publish my online presence on the World Wide Web" and
//   "Do not publish IP address"
// Window for "Add your own personalized message" was added.
// Window for "More Email addresses" was added.
// Window for "For Tech Support" was added.
// Some work for error handling during registration was added.
//

#include <qlayout.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <kapp.h>

#include "techwin.h"

#include "techwin.moc"

TechWindow::TechWindow(QString host, unsigned short port, QWidget *p) : QDialog(p, 0, TRUE)
{
  QBoxLayout *topLayout = new QVBoxLayout(this, 7);

  QLabel *label = new QLabel(
    i18n("If technical support advised you to connect to\n" \
         "another server, enter its address here."), this);
  label->setMinimumSize(label->sizeHint());
  topLayout->addWidget(label, 1);

  QGridLayout *hostPortLayout = new QGridLayout(2, 2);
  topLayout->addLayout(hostPortLayout);

  QLabel *hostLabel = new QLabel(i18n("Address:"), this);
  hostLabel->setMinimumSize(hostLabel->sizeHint());
  hostPortLayout->addWidget(hostLabel, 0, 0);

  hostLine = new QLineEdit(this);
  hostLine->setMinimumSize(hostLine->sizeHint());
  hostLine->setMaximumHeight(hostLine->sizeHint().height());
  hostLine->setText(host);
  hostPortLayout->addWidget(hostLine, 1, 0);

  QLabel *portLabel = new QLabel(i18n("Port:"), this);
  portLabel->setMinimumSize(portLabel->sizeHint());
  hostPortLayout->addWidget(portLabel, 0, 1);

  portLine = new KIntegerLine(this);
  portLine->setFixedSize(portLine->fontMetrics().width("9999999"), portLine->sizeHint().height());
  portLine->setValue(port);
  hostPortLayout->addWidget(portLine, 1, 1);

  QBoxLayout *butLayout = new QHBoxLayout(7);
  topLayout->addLayout(butLayout);

  butLayout->addStretch(1);

  QPushButton *okbtn = new QPushButton(i18n("Ok"), this);
  okbtn->setMaximumHeight(okbtn->sizeHint().height());
  okbtn->setDefault(TRUE);
  connect(okbtn, SIGNAL(clicked()), SLOT(accept()));
  butLayout->addWidget(okbtn);

  QPushButton *cancelbtn = new QPushButton(i18n("Cancel"), this);
  cancelbtn->setMaximumHeight(cancelbtn->sizeHint().height());
  connect(cancelbtn, SIGNAL(clicked()), SLOT(reject()));
  butLayout->addWidget(cancelbtn);

  int w = QMAX(okbtn->sizeHint().width(), cancelbtn->sizeHint().width());
  okbtn->setMinimumSize(w, okbtn->sizeHint().height());
  cancelbtn->setMinimumSize(w, cancelbtn->sizeHint().height());

  butLayout->addStretch(1);

  topLayout->activate();

  setCaption(i18n("Enter Server Address"));

  resize(1,1);
}

QString TechWindow::host()
{
  return hostLine->text();
}

unsigned short TechWindow::port()
{
  return portLine->value();
}
