/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: detailswidget.cpp,v 1.2 2000/05/29 02:14:39 bills Exp $
// $Log: detailswidget.cpp,v $
// Revision 1.2  2000/05/29 02:14:39  bills
// minor spelling/grammar fixes
//
// Revision 1.1  2000/05/24 16:59:32  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.8  2000/01/10 16:08:10  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.7  1999/10/14 12:47:28  denis
// QBoxLayout's changed to QGridLayout.
//
// Revision 1.6  1999/09/29 17:37:34  denis
// Layout widget stuff implemented.
//
// Revision 1.5  1999/07/16 15:47:47  denis
// Cleaned up.
//
// Revision 1.4  1999/07/16 13:01:29  denis
// Internalization support added.
//
// Revision 1.3  1998/12/08 16:10:04  denis
// Cleaned up a little before releasing
//

#include <qlayout.h>
#include <qgrpbox.h>
#include <qlabel.h>
#include <kapp.h>

#include "detailswidget.h"

#include "detailswidget.moc"

DetailsWidget::DetailsWidget(QWidget *parent) : QWidget(parent)
{
  QBoxLayout *topLayout = new QVBoxLayout(this, 7);

  QGroupBox *detbox = new QGroupBox(i18n("Search Users By Parameters"),this);

  QGridLayout *boxLayout = new QGridLayout(detbox, 7, 5);
  boxLayout->setRowStretch(0, 1);
  boxLayout->setRowStretch(2, 1);
  boxLayout->setRowStretch(4, 1);
  boxLayout->setRowStretch(6, 1);
  boxLayout->setColStretch(3, 1);
  boxLayout->addRowSpacing(0, 15);
  boxLayout->addRowSpacing(2, 7);
  boxLayout->addRowSpacing(4, 7);
  boxLayout->addRowSpacing(6, 7);
  boxLayout->addColSpacing(0, 7);
  boxLayout->addColSpacing(2, 7);
  boxLayout->addColSpacing(4, 7);

  QLabel *nicklabel = new QLabel(i18n("Nickname:"),detbox);
  nicklabel->setMinimumSize(nicklabel->sizeHint());
  boxLayout->addWidget(nicklabel, 1, 1);

  nickline = new QLineEdit(detbox);
  nickline->setMinimumSize(nickline->sizeHint());
  nickline->setMaximumHeight(nickline->sizeHint().height());
  boxLayout->addWidget(nickline, 1, 3);

  QLabel *firstlabel = new QLabel(i18n("First Name:"),detbox);
  firstlabel->setMinimumSize(firstlabel->sizeHint());
  boxLayout->addWidget(firstlabel, 3, 1);

  firstline = new QLineEdit(detbox);
  firstline->setMinimumSize(firstline->sizeHint());
  firstline->setMaximumHeight(firstline->sizeHint().height());
  boxLayout->addWidget(firstline, 3, 3);

  QLabel *lastlabel = new QLabel(i18n("Last Name:"),detbox);
  lastlabel->setMinimumSize(lastlabel->sizeHint());
  boxLayout->addWidget(lastlabel, 5, 1);

  lastline = new QLineEdit(detbox);
  lastline->setMinimumSize(lastline->sizeHint());
  lastline->setMaximumHeight(lastline->sizeHint().height());
  boxLayout->addWidget(lastline, 5, 3);

  boxLayout->activate();
  topLayout->addWidget(detbox, 1);

  topLayout->activate();
}

const char *DetailsWidget::nick()
{
  return nickline->text();
}

const char *DetailsWidget::first()
{
  return firstline->text();
}

const char *DetailsWidget::last()
{
  return lastline->text();
}

void DetailsWidget::clear()
{
  nickline->setText("");
  firstline->setText("");
  lastline->setText("");
}
