/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: emailwidget.cpp,v 1.2 2000/05/29 02:14:39 bills Exp $
// $Log: emailwidget.cpp,v $
// Revision 1.2  2000/05/29 02:14:39  bills
// minor spelling/grammar fixes
//
// Revision 1.1  2000/05/24 16:59:32  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.9  2000/01/10 16:08:12  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.8  1999/12/02 14:09:29  denis
// GUI little tweak.
//
// Revision 1.7  1999/10/14 12:50:59  denis
// Cleanups.
//
// Revision 1.6  1999/09/29 17:37:36  denis
// Layout widget stuff implemented.
//
// Revision 1.5  1999/07/16 15:47:51  denis
// Cleaned up.
//
// Revision 1.4  1999/07/16 13:02:03  denis
// Internalization support added.
//
// Revision 1.3  1998/12/08 16:15:28  denis
// Cleaned up a little before releasing
//

#include <qlayout.h>
#include <qlabel.h>
#include <qgrpbox.h>
#include <kapp.h>

#include "emailwidget.h"

#include "emailwidget.moc"

EMailWidget::EMailWidget(QWidget *parent) : QWidget(parent)
{
  QBoxLayout *topLayout = new QVBoxLayout(this, 7);

  QLabel *label1 = new QLabel(i18n("Enter user's E-mail address:"),this);
  label1->setMinimumSize(label1->sizeHint());
  topLayout->addWidget(label1);

  QGroupBox *emailbox = new QGroupBox(i18n("Search Users By E-mail"), this);

  QBoxLayout *boxLayout = new QHBoxLayout(emailbox, 10, 7);

  boxLayout->addSpacing(7);

  QLabel *label2 = new QLabel(i18n("EMail:"), emailbox);
  label2->setMinimumSize(label2->sizeHint());
  boxLayout->addWidget(label2);

  emailline = new QLineEdit(emailbox);
  emailline->setMinimumSize(emailline->sizeHint());
  emailline->setMaximumHeight(emailline->sizeHint().height());
  boxLayout->addWidget(emailline, 1);

  boxLayout->activate();
  topLayout->addWidget(emailbox, 1);

  topLayout->activate();
}

const char *EMailWidget::email()
{
  return emailline->text();
}

void EMailWidget::clear()
{
  emailline->setText("");
}
