/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _FINDWINDOW_
#define _FINDWINDOW_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qdialog.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qlistview.h>
#include <ktabctl.h>

class EMailWidget;
class DetailsWidget;
class UINWidget;

class FindWindow : public QDialog {
  Q_OBJECT
public:
  FindWindow();

  // callbacks
  static void userFound(ICQLINK *link, unsigned long uin, const char *nick, const char *first,
                        const char *last, const char *email, char auth);
  static void searchDone(ICQLINK *link);
public slots:
  void addRequest();
  void infoRequest();
  void popupRequest(QListViewItem*, const QPoint&, int);
  void stopCommand();
  void clearCommand();
signals:
protected:
  KTabCtl *tabctl;
  EMailWidget *emailwidget;
  DetailsWidget *detailswidget;
  UINWidget *uinwidget;
  QPushButton *searchbtn, *stopbtn, *newbtn;
  QLabel *searchanim;
  QListView *foundlist;
  QPopupMenu *popup;
  int curtab;
  void resizeEvent(QResizeEvent *);
  void addUserLine(unsigned long uin, const char *nick, const char *first, const char *last,
                   const char *email, char auth);
protected slots:
  void searchCommand();
  void changeTab(int);
private:
private slots:
};
#endif /* _FINDWINDOW_ */
