/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: uinwidget.cpp,v 1.2 2000/05/29 02:14:39 bills Exp $
// $Log: uinwidget.cpp,v $
// Revision 1.2  2000/05/29 02:14:39  bills
// minor spelling/grammar fixes
//
// Revision 1.1  2000/05/24 16:59:32  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.9  2000/01/10 16:09:24  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.8  1999/12/02 14:09:16  denis
// GUI little tweak.
//
// Revision 1.7  1999/10/14 12:57:18  denis
// Cleanups.
//
// Revision 1.6  1999/09/29 17:37:40  denis
// Layout widget stuff implemented.
//
// Revision 1.5  1999/07/16 15:49:00  denis
// Cleaned up.
//
// Revision 1.4  1999/07/16 13:12:27  denis
// Internalization support added.
//
// Revision 1.3  1998/12/08 16:31:23  denis
// Cleaned up a little before releasing
//

#include <qlayout.h>
#include <qlabel.h>
#include <qgrpbox.h>
#include <kapp.h>

#include "uinwidget.h"

#include "uinwidget.moc"

UINWidget::UINWidget(QWidget *parent) : QWidget(parent)
{
  QBoxLayout *topLayout = new QVBoxLayout(this, 7);

  QLabel *label1 = new QLabel(i18n("Enter user's ICQ number:"),this);
  label1->setMinimumSize(label1->sizeHint());
  topLayout->addWidget(label1);

  QGroupBox *uinbox = new QGroupBox(i18n("Search Users By ICQ #"), this);

  QBoxLayout *boxLayout = new QHBoxLayout(uinbox, 10, 7);

  boxLayout->addSpacing(7);

  QLabel *label2 = new QLabel(i18n("ICQ#:"), uinbox);
  label2->setMinimumSize(label2->sizeHint());
  boxLayout->addWidget(label2);

  uinline = new KIntegerLine(uinbox);
  uinline->setMinimumSize(uinline->sizeHint());
  uinline->setMaximumHeight(uinline->sizeHint().height());
  boxLayout->addWidget(uinline, 1);

  boxLayout->activate();
  topLayout->addWidget(uinbox, 1);

  topLayout->activate();
}

void UINWidget::clear()
{
  uinline->setText("");
}

unsigned long UINWidget::uin()
{
  return uinline->value();
}

int UINWidget::isEmpty()
{
  return strlen(uinline->text())==0;
}
