/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: connectbutton.cpp,v 1.2 2000/07/24 19:05:07 denis Exp $
// $Log: connectbutton.cpp,v $
// Revision 1.2  2000/07/24 19:05:07  denis
// ICQ button animation was implemented!
//
// Revision 1.1  2000/05/24 16:59:50  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.7  2000/01/10 16:08:08  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.6  1999/12/02 13:58:49  denis
// Cleanups.
//
// Revision 1.5  1999/07/16 15:47:45  denis
// Cleaned up.
//
// Revision 1.4  1999/07/16 13:01:14  denis
// Internalization support added.
//
// Revision 1.3  1998/12/08 16:09:37  denis
// Cleaned up a little before releasing
//

#include <qpainter.h>
#include <qpixmap.h>

#include "connectbutton.h"
#include "mainwindow.h"

#include "connectbutton.moc"

ConnectButton::ConnectButton(QWidget *parent, const char *name) : QPushButton(parent, name)
{
  timerid = -1;
  loader = kapp->getIconLoader();
  setStatus(stOffline);
}

ConnectButton::~ConnectButton()
{
  killTimers();
}

void ConnectButton::drawButtonLabel(QPainter *p)
{
  p->drawPixmap(6, 3, lpixmap);
  p->drawText(lpixmap.width()+13, 0, width()-13-lpixmap.width(), height(), AlignLeft|AlignVCenter, ltext);
}

void ConnectButton::setStatus(icqStatus status)
{
  switch(status)
  {
    case stOnline:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = loader->loadIcon("online.xpm");
      ltext = i18n("Online");
      break;
    case stAway:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = loader->loadIcon("away.xpm");
      ltext = i18n("Away");
      break;
    case stDND:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = loader->loadIcon("dnd.xpm");
      ltext = i18n("DND");
      break;
    case stNA:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = loader->loadIcon("na.xpm");
      ltext = i18n("N/A");
      break;
    case stOccupied:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = loader->loadIcon("occupied.xpm");
      ltext = i18n("Occupied");
      break;
    case stFFC:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = loader->loadIcon("freechat.xpm");
      ltext = i18n("Free Chat");
      break;
    case stInvisible:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = loader->loadIcon("privacy.xpm");
      ltext = i18n("Privacy");
      break;
    case stOffline:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = loader->loadIcon("offline.xpm");
      ltext = i18n("Offline");
      break;
    case stLogin:
      if(timerid==-1)
      {
        picnum = 1;
        lpixmap = loader->loadIcon("connect1.xpm");
        ltext = i18n("Connecting");
        timerid = startTimer(1000);
      }
      break;
  }
  MW->setIcon(lpixmap);
  update();
}

void ConnectButton::timerEvent(QTimerEvent *te)
{
  QString filename;
  if(te->timerId()==timerid)
  {
    picnum++;
    if(picnum>8)
      picnum = 1;
    filename.sprintf("connect%i.xpm", picnum);
    lpixmap = loader->loadIcon(filename);
    MW->setIcon(lpixmap);
    update(6, 3, lpixmap.width(), lpixmap.height());
  }
}
