/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: icqanimbutton.cpp,v 1.1 2000/07/24 19:05:07 denis Exp $
// $Log: icqanimbutton.cpp,v $
// Revision 1.1  2000/07/24 19:05:07  denis
// ICQ button animation was implemented!
//
#include <stdio.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <kapp.h>
#include <kiconloader.h>

#include "icqanimbutton.h"

#include "icqanimbutton.moc"

IcqAnimButton::IcqAnimButton(QWidget *parent, const char *name) : QPushButton(parent, name)
{
  timerid = -1;
  loader = kapp->getIconLoader();
//   printf("a: %s\n", (const char*)loader->getIconPath("icq1.xpm"));
  setMouseTracking(TRUE);
  setAnimButtonStatus(stop);
}

IcqAnimButton::~IcqAnimButton()
{
  killTimers();
}

void IcqAnimButton::drawButtonLabel(QPainter *p)
{
//   printf("draw (%i, %i)\n", lpixmap.width(), lpixmap.height());
  p->drawPixmap(2, 2, lpixmap);
}

void IcqAnimButton::setAnimButtonStatus(IcqAnimStatus status)
{
//   printf("status\n");
  switch(status)
  {
    case stop:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = loader->loadIcon("icq1.xpm");
//       printf("icq1.xpm (%i, %i)\n", lpixmap.width(), lpixmap.height());
      break;
    case start:
      if(timerid==-1)
      {
        picnum = 1;
        lpixmap = loader->loadIcon("icq1.xpm");
        timerid = startTimer(100);
      }
      break;
  }
  update(2, 2, lpixmap.width(), lpixmap.height());
}

void IcqAnimButton::timerEvent(QTimerEvent *te)
{
  QString filename;
  if(te->timerId()==timerid)
  {
//     printf("timer %i\n", picnum);
    picnum++;
    if(picnum>17)
      picnum = 17;
    filename.sprintf("icq%i.xpm", picnum);
    lpixmap = loader->loadIcon(filename);
    update(2, 2, lpixmap.width(), lpixmap.height());
  }
}

void IcqAnimButton::mouseMoveEvent(QMouseEvent *e)
{
//  printf("x=%i, y=%i\n", e->x(), e->y());
  QPushButton::mouseMoveEvent(e);
  if(hitButton(e->pos()))
  {
//    printf("Grab\n");
    setAnimButtonStatus(start);
    grabMouse();
  }
  else
  {
//    printf("Release\n");
    setAnimButtonStatus(stop);
    releaseMouse();
  }
}

QSize IcqAnimButton::sizeHint() const
{
  return lpixmap.size();
}
