/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: klineeditwithpopupmenu.cpp,v 1.1 2000/05/24 16:59:50 denis Exp $
// $Log: klineeditwithpopupmenu.cpp,v $
// Revision 1.1  2000/05/24 16:59:50  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.5  2000/01/10 16:08:39  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//

#include "klineeditwithpopupmenu.h"

#include "klineeditwithpopupmenu.moc"


KLineEditWithPopupMenu::KLineEditWithPopupMenu(QWidget *parent) : QLineEdit(parent)
{
  popupmenu = NULL;
}

KLineEditWithPopupMenu::~KLineEditWithPopupMenu()
{
  if(popupmenu != NULL)
    delete popupmenu;
}

QPopupMenu* KLineEditWithPopupMenu::popup()
{
  if(popupmenu == NULL)
  {
    popupmenu = new QPopupMenu();
  }

  return popupmenu;
}

void KLineEditWithPopupMenu::mousePressEvent(QMouseEvent *e) 
{ 
  QLineEdit::mousePressEvent(e);

  if((e->button() == RightButton) && (popupmenu != NULL))
  {
    popupmenu->popup(QCursor::pos());
  }
}
