/***************************************************************************
                          kwebbrowser.cpp  -  description                              
                             -------------------                                         
    begin                : Tue Aug 31 1999                                           
    copyright            : (C) 1999 by Markus Goetz                         
    email                : guruz@gmx.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "kwebbrowser.h"
#include <stdlib.h>
#include <unistd.h>
#include <qclipboard.h>
#include <ksimpleconfig.h>
#include <kapp.h>
#include <qstring.h>
#include <qdir.h>

#include "kwebbrowser.moc"

KWebBrowser::KWebBrowser()
{
}

KWebBrowser::~KWebBrowser()
{
}

void KWebBrowser::callWebBrowser(QString URL)
{
 int browser = getBrowser();
 if (URL.left(7) == "mailto:") browser = BROWSER_KFM;

 QString stringbrowser;

 switch (browser)
 {
  case BROWSER_KFM:          { system(QString("kfmclient openURL '" + URL + "' &"));
                               stringbrowser = "KFM";
                               break; }

  case BROWSER_CLIPBOARD:    { kapp->clipboard()->setText(URL);
                               stringbrowser = "Clipboard";
                               break; }

  case BROWSER_NETSCAPE:     { QString homedir  = getenv("HOME");
                               QString lockfile = QString(homedir + "/.netscape/lock");
                               if (system(QString("test -L " + lockfile)) == 0)
                               system(QString("netscape -remote 'openURL(" + URL + ",new-window)'" + " &"));
                               else
                               system(QString("netscape '" + URL + "' &"));
                               sleep(2);
                               stringbrowser = "Netscape";
                               break; }

  case BROWSER_NETSCAPE_NSS: { system(QString("netscape '" + URL + "' &"));
                               stringbrowser = "Netscape";
                               break; }

  case BROWSER_LYNX:         { system(QString("konsole -e lynx '" + URL + "' &"));
                               stringbrowser = "Lynx";
                               break; }
  case BROWSER_WGET:         { system(QString("konsole -e bash -c \"wget '" + URL + "' ; read\"&"));
                               stringbrowser = "Wget";
                               break; }

 };


}

// Yes, the following things are fully alright !!!!! It mustn't /kicq/options !!!!

void KWebBrowser::setBrowser(int id)
{
  QDir *directory = new QDir;
  directory->mkdir(kapp->localkdedir() + "/share/apps/kwebsearch/");
  delete directory; 
  KSimpleConfig config(kapp->localkdedir() + "/share/apps/kwebsearch/options");
  config.setGroup("Options");
  config.writeEntry("browser", id);
}



int KWebBrowser::getBrowser()
{
  QDir *directory = new QDir;
  directory->mkdir(kapp->localkdedir() + "/share/apps/kwebsearch/");
  delete directory; 
  KSimpleConfig config(kapp->localkdedir() + "/share/apps/kwebsearch/options");
  config.setGroup("Options");
  int id = config.readNumEntry("browser",0);
  return id;
}













