/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _WRAPEDIT_H
#define _WRAPEDIT_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qmlined.h>

class QPopupMenu;

class WrapEdit : public QMultiLineEdit
{
  Q_OBJECT
public:
  WrapEdit(QWidget *p = 0, const char *n = 0);
  ~WrapEdit();
  void quote() ;
  void setWraping(bool) ;
  bool isWraping() ;
  void setLimit(unsigned int);
  unsigned int getLimit();
protected:
  bool wrap ;
  bool needUpdate;
  QStrList *quickphrases_string_list;
  QPopupMenu *popupmenu;
  unsigned int limit;
  void keyPressEvent(QKeyEvent *) ;
  void resizeEvent(QResizeEvent*);
  void wrapText(int r=-1);
  void mousePressEvent(QMouseEvent*); 
protected slots:
  void activatedItem(int itemId);
};

#endif /* _WRAPEDIT_H */
